<?php

/*************************************************************
 * Contact us controller
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/
class firstPageBasedControllerController extends controller {

	public $validation,$trans;

	/**
	 * Initialize the required class and variables
	 */
	protected function init() {

		//	trigger_error("ddddddd");

		$this->addCssIncludes("css/demo.css");
		/*		$this->addJsIncludes("js/contactUs.js");
				$this->unsetOperator("serverLoad");

				$this->trans = basic::load("trans","core");
				$this->trans->loadTrans("contactUs");*/
	}

	/**
	 * Before action - the function that comes before all the functions in the controller class
	 */
	function beforeAction() {
	}

	/**
	 * Index - the default action
	 * @return string - the view content
	 */
	public function index() {

		//	$auth   = basic::load("auth","core");
		//	$userId = $auth->getUserLoggedUserId();

		$mu = "";
		if(lang::getCurrentLanguage()!="en") {
			$mu = " multi language";
		}

		$this->view->title = "This is: First page based controller (MVC)".$mu;

		$data                  = $this->model->getData();
		$this->view->firstLine = $data->firstLine;

		return $this->view();
	}

	/**
	 * Page num 2 based controller - action
	 * @param $width - get from the url
	 * @param $height - get from the url
	 * @param dependencyDemo $dependency - dependency
	 * @return string - the view content
	 */
	public function pageNum2BasedController($width,$height,dependencyDemo $dependency) {

		$mu = "";
		if(lang::getCurrentLanguage()!="en") {
			$mu = " multi language";
		}

		$this->view->title = "This is: Page num 2 based controller (MVC)".$mu;

		$validation = basic::load("validation","functions");
		$width = isset($width['GET']) ? $validation->validate($width['GET'],"int",10,"required","width") : false;
		$height = isset($height['GET']) ? $validation->validate($height['GET'],"int",10,"required","height") : false;

		$data                  = $this->model->getData();
		$this->view->firstLine = $data->firstLine;
		$this->view->width     = $width;
		$this->view->height    = $height;
		$this->view->area      = $dependency->calculateArea($width,$height);

		$this->trans = basic::load("trans","core");
		$this->trans->loadTrans("demo");

		$textForSecondLine = $this->trans->T("All requests method such as: GET,POST,DELETE and UPDATE are being catch by the controller, we can use them as shown in this demo. on the url we added: <code>?width=40&height=80</code> after the http address of this page to simulate \"GET\" request. on the controller (file number 2) declaration for this page we catch the parameters: <code>public function pageNum2BasedController(\$width,\$height...</code>. the parameters can be disordered and the controller will get them by name. we now can print the parameters we catch on \"view\" (file number 1) with the function: <code>p(\$this->width);</code>. this funtion will help us to print on screen (and log file) any value we want to, even array and objects.");

		$this->view->textForSecondLine = $textForSecondLine;

		return $this->view();
	}

	private function whoAreYou() {

		echo"me";
	}
}
