<?php

/*************************************************************
 * Default theme class - minimal theme
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/
class blankTheme extends template {

	public $templatePlan;
	public $topPanelR;
	public $showSidePanelR;
	public $operatorsInsideR;
	public $topPanelL;
	public $showSidePanelL;
	public $operatorsInsideL;

	/**
	 * Constructor for blank theme - do not allow constructor here cz it will disable the template constructor
	 * @param string $controller
	 * @param string $action
	 * @param string $architectureType
	 */
	public function __construct($controller,$action,$architectureType) {

		parent::__construct($controller,$action,$architectureType);
	}

	/**
	 * Template plan
	 * @return array - the files that will be used at this theme
	 */
	public function templatePlan() {

		return $this->templatePlan = array(
			"metaHead",
			"mainEvent",
		);
	}

	/**
	 * Template plan cleaned - clean design template
	 * @return array - the files that will be used at this theme
	 */
	public function templatePlanCleaned() {

		return $this->templatePlan = array(
			"metaHead",
			"mainEvent",
		);
	}

	/**
	 * Js includes
	 * @return array - the js files that will be used at this theme
	 */
	public function jsIncludes() {

		$jsInclude = array();

		return $jsInclude;
	}

	/**
	 * Css includes
	 * @return array - the css files that will be used at this theme
	 */
	public function cssIncludes() {

		$cssInclude[] = "css/pageAuthVer.css";      // for auth class

		return $cssInclude;
	}

	/**
	 * Js
	 * @return string - the js script that will be used in this theme
	 */
	public function js() {

		//	return $js = "!window.jQuery && document.write(unescape('%3Cscript src=\"http://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js\"%3E%3C/script%3E'))";
	}

	/**
	 * Css
	 * @return string - the css script that will be used in this theme
	 */
	public function css() {

		return $css = "";
	}

	/**
	 * Header - like a controller for middle file, $this->aaa will remain $this->aaa on header
	 */
	public function header() {

		$this->cssIncludes[] = "";
	}

  /**
   * Notif - the way we pop up the notifications
   * @param string $text - text to display
   * @param string $notifType - css to use for this alert
   * @param string $link - link inside alert
   * @param string $linkText - link text inside alert
   * @param string $more - more usability for future function
   * @param string /integer/boolean $breakOut - if we break the alert to normal html text
   * @return string - the output
   */
  static function notif($text,$notifType = "option",$link = "",$linkText = "",$more = "",$breakOut = "") {

    global $allowAjaxSaving,$notif;

    $allowAjaxSaving = 1;

    if($notifType=="warning") {
      error_log("Issued Alert popup - ".stripslashes($text));
    }

//	if(headers_sent()) {	// have to check with ajax too

    $lifeSpan = 5000;

    if(isset($more['lifeSpan'])) {
      $lifeSpan = $more['lifeSpan'];
    }

    if($link) {
      $link = "&nbsp;<a href=\"$link\">$linkText</a>";
    }
    if($more=="seconed") {
      $second = "2";
    }
    else $second = "";

    $position = "";
    if($notifType=="efficiency") {
      $position = "position:'bottom-right',";
    }

    if($allowAjaxSaving==1 && $breakOut!=1) {    // $breakOut - for it to always display this massage in regular html and not js
      //  header: '".$notifType."',	// to put inside: $.jGrowl(
      //	$output = "<script type=\"text/javascript\">$.jGrowl('".$text.$link."',{".$position." theme:'".$notifType."',life:".$lifeSpan."});tops();</script>\n";

      $output = "<div class=\"notifUiNum bozoNotification alert ui-state-highlight ui-corner-all ".$notifType."\" data-notifNum=\"\" data-notifType=\"".$notifType."\" data-notifLifeSpan=\"".$lifeSpan."\" data-notifPosition=\"\" data-notifTheme=\"\" style=\"display:none;\">
							<button class=\"bozoClose\">×</button>
							<div class=\"bozoHeader\"></div>
							<div class=\"bozoMessage\">
								".$text.$link."
							</div>
						</div>";        // display:none; must stay to prevent showing before page is up with css
    }
    else {
      $output = "<div id=\"alert-noti$second\">";

      //	$output .= openTable();

      $output .= "<span class=\"$notifType\">$text$link</span><span class=\"close\"><a href=\"javascript:animatedcollapse.toggle('alert-noti$second');\" title=\"close\">X</a>aa</span>";

      //	$output .= closeTable();

      $output .= "<p></p>";
      $output .= "</div>";
    }    // a box on the page

    if(headers_sent() || myHelpers::isAjax()) {
      echo $output;
    }
    else {
      $notif .= $output;

      return $notif;
    }    // for sending the alert at the end of the render
  }

  /**
   * Js notification - send notification from ajax
   * @return string
   */
  static function jsNotif() {

    $script = "<script>function notification(text,type) {

	//	alert('No connection');
	var alert = '<div class=\"notifUiNum bozoNotification alert ui-state-highlight ui-corner-all red\" data-notifNum=\"\" data-notifType=\"+type+\" data-notifLifeSpan=\"99999\" data-notifPosition=\"\" data-notifTheme=\"\" style=\"display:none;\"><button class=\"bozoClose\">×</button><div class=\"bozoHeader\"></div><div class=\"bozoMessage\">'+text+'</div></div>';

	document.body.innerHTML = document.body.innerHTML + alert;
}</script>";        // display:none; must stay to prevent showing before page is up with css

    return $script;
  }
}

