<p><span class="titleIt"><?=$this->title?></span>
</p>
<p></p>
<p></p>

<div class="containIt">
	<p>
		<?=$this->firstLine?>
	</p>

	<?php
	if(lang::getCurrentLanguage()===lang::getDefaultLanguage()) {
		?>
		<p>
			We can edit the "view" file (file number 1) and the content of this page will be changed.
		</p>
		<p>
			Controllers have actions that's operates and run under it's name. action function name does not have to
			start with the word "action", we simply choose the name we want to use as a function (file number 2). in
			this page we are using <code>public function index() {</code> as a controller since we don't want anything
			other then the controller name in the url.
		</p>
		<p>
			If we want to make a function that won't be an action, we simply make it private (file number 2), such as
			<code>private function whoAreYou() {</code>. private functions can't be called as action. we can only use it
			inside the controller, but can be called from other controllers as well with the help of core function - we
			won't show in this demo.
		</p>
		<p>
			With the help of the controller (file number 2) we can insert variables to the content of this page - for
			passing variables like the "title", we used <code>$this->view->title</code> in the controller. to put it in
			the view file (file number 1) we used <code>$this->title</code> for the same variable.
		</p>
		<p>
			To get data from the "model" into the "controller" and then passing it to the "view", we have to fetch it
			first. here in this demonstration we will use a builtin function and not "mysql" as common framework will
			do, but
			for sure it is possible here too. what we want to do in this demo is to get/show the first line of this page
			text from the model and by the controller. the model file (file number 3) can fetch the data for us - <code>function
				getData()</code> will do just so with the help of <code>$this->loadData($name)</code> we are getting the
			data from the data file (file number 4) by giving the function the parameter of the file location that holds
			the
			data (file number 4) <code>"demonstrationData".DS."main"</code>. after we have the data needed, we can
			assign
			the data to the view for display: <code>$this->view->firstLine = $data->firstLine</code>.
		</p>
		<p>
			In the controller we can also assign css/js files, we can do that by using the <code>function init()</code>
			that
			every controller should have. <code>$this->addCssIncludes("css/demo.css")</code> will insert the css file
			(file
			number 5) into the html head of this page according to site configuration.
		</p>
		<p>
			Notice the url routing at our browser http address. if we want to inflict the first string after the domain
			and
			after the "/" sign, we will use <span class="fileIt">index.php</span> at the directory we want to
			use as string on the url. in this example we use the <span class="fileIt">firstPageBasedController</span>
			directory.
		</p>
		<?php
	}
	elseif(lang::getCurrentLanguage()=="xx-xx") {
		?>

		<p>
			Because this page have to appear in other language and after all this is only a tutorial, to simulate multi
			language page, we will use <code>lang::getCurrentLanguage()</code> on the "view file (file number 1) for
			checking the current language set for this page and with the result we can define what text appear when.
		</p>

		<?php
	}
	?>

	<p></p>
	<p class="underlineIt">Files in use: (not including template files)</p>
	<p>
		1 - View (a must): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>views<span><?=DS?></span>firstPageBasedController<span><?=DS?></span>index.php</span>
	</p>
	<p>
		2 - Controller (a must): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>controllers<span><?=DS?></span>firstPageBasedControllerController.php</span>
	</p>
	<p>
		3 - Model (optional): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>models<span><?=DS?></span>firstPageBasedControllerModel.php</span>
	</p>
	<p>
		4 - Model data (db like) (optional): <span
			class="fileIt">source<span><?=DS?></span>data<span><?=DS?></span>demonstrationData<span><?=DS?></span>main.php</span>
	</p>
	<p>
		5 - Css (optional): <span
			class="fileIt">public<span><?=DS?></span>css<span><?=DS?></span>demo.css</span>
	</p>
	<p></p>
	<p class="underlineIt">Navigate:</p>
	<p><a href="<?=lang::languageUrlStart()?>">homePage</a> - Home page</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedView">firstPageBasedView</a> - First page based "view"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedView">firstPageBasedViewMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedView/pageNum2BasedView">pageNum2BasedView</a> - Page number 2 based "view"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedView/pageNum2BasedView">pageNum2BasedViewMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedController">firstPageBasedController</a> - First page based "controller"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedController">firstPageBasedControllerMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedController/pageNum2BasedController?height=80&width=40">pageNum2BasedController</a> - Page number 2 based "controller"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedController/pageNum2BasedController?height=80&width=40">pageNum2BasedControllerMu</a> - For multi language support
	</p>
	<p></p>
</div>

