<p><span class="titleIt"><?=$this->title?></span>
</p>
<p></p>
<p></p>

<div class="containIt">
	<p>
		<?=$this->firstLine?>
	</p>
	<p>
		<?=$this->textForSecondLine?>
	</p>

	<?php
	if(lang::getCurrentLanguage()===lang::getDefaultLanguage()) {
		?>
		<p>
			width param:
			<?=p($this->width)?>
			height param:
			<?=p($this->height)?>
		</p>
		<p>
			We can also print all the catches params by the router, like: GET, POST, PUT, DELETE, PATCH and ect... with
			the function: <code>router::getAllParams()</code>

			<?=p(router::getAllParams())?>
		</p>
		<p>
			We can validate the user/client inputs with the "validation" class, like this:
			<code>
				$validation = basic::load("validation","functions");
			</code><br>
			<code>
				$width = isset($width['GET']) ? $validation->validate($width['GET'],"int",10,"required","width") : false;
			</code><br>
			<code>
				$height = isset($height['GET']) ? $validation->validate($height['GET'],"int",10,"required","height") : false;
			</code>
		</p>
		<p>
			On the controller declaration we can load dependencies. we will want to load the dependencies only after we
			catch the requests and not before them, if not code malfunctions may occur. in this demo we declared: <code>public
				function pageNum2BasedController($width,$height,dependencyDemo $dependency) {</code> that means that we
			want to use the dependency file (file number 6), we can call it's function like this: <code>$dependency->calculateArea($width['GET'],$height['GET'])</code>
			passing the width and height, we can calculate the "area".
		</p>
		<p>
			calculated area:
			<?=p($this->area)?>
		</p>
		<p>
			In case of a bad input on the url, let's say that we changing the width in the browser url to a word instead
			of number or delete the width completely. a notification will pop up to inform us we have a problem. first
			we load the notif class object <code>$notif = basic::load("notif","core");</code> and then we choose the
			notif file and number to show <code>$notif->genNotifByNum("demo",12345);</code>.
		</p>
		<?php
	}
	?>
	<p></p>
	<p class="underlineIt">Files in use: (not including template files)</p>
	<p>
		1 - View (a must): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>views<span><?=DS?></span>firstPageBasedController<span><?=DS?></span>pageNum2BasedController.php</span>
	</p>
	<p>
		2 - Controller (a must): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>controllers<span><?=DS?></span>firstPageBasedControllerController.php</span>
	</p>
	<p>
		3 - Model (optional): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>models<span><?=DS?></span>firstPageBasedControllerModel.php</span>
	</p>
	<p>
		4 - Model data (db like) (optional): <span
			class="fileIt">source<span><?=DS?></span>data<span><?=DS?></span>demonstrationData<span><?=DS?></span>main.php</span>
	</p>
	<p>
		5 - Css (optional): <span
			class="fileIt">public<span><?=DS?></span>css<span><?=DS?></span>demo.css</span>
	</p>
	<p>
		6 - Dependency (optional): <span
			class="fileIt">architecture<span><?=DS?></span>application<span><?=DS?></span>controllers<span><?=DS?></span>dependencyDemo.php</span>
	</p>
	<p>
		7 - Notification (optional): <span
			class="fileIt">source<span><?=DS?></span>text<span><?=DS?></span>notifs<span><?=DS?></span>en<span><?=DS?></span>demo.php</span>
	</p>
	<p>
		8 - Translation (optional): <span
			class="fileIt">source<span><?=DS?></span>text<span><?=DS?></span>translations<span><?=DS?></span>xx-xx<span><?=DS?></span>demo.php</span>
	</p>
	<p></p>
	<p class="underlineIt">Navigate:</p>
	<p><a href="<?=lang::languageUrlStart()?>">homePage</a> - Home page</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedView">firstPageBasedView</a> - First page based "view"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedView">firstPageBasedViewMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedView/pageNum2BasedView">pageNum2BasedView</a> - Page number 2 based "view"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedView/pageNum2BasedView">pageNum2BasedViewMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedController">firstPageBasedController</a> - First page based "controller"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedController">firstPageBasedControllerMu</a> - For multi language support
	</p>
	<p>
		<a href="<?=lang::languageUrlStart()?>/firstPageBasedController/pageNum2BasedController?height=80&width=40">pageNum2BasedController</a> - Page number 2 based "controller"
		<span>&nbsp;</span>
		<a href="<?=lang::languageUrlStart("xx-xx")?>/firstPageBasedController/pageNum2BasedController?height=80&width=40">pageNum2BasedControllerMu</a> - For multi language support
	</p>
	<p></p>
</div>

