<?php

/*************************************************************
 * Login controller class
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/
class loginController extends operatorsController {

	public $view;

	/**
	 * Initialize the required classes and variables
	 */
	public function init() {

		$this->addCssIncludes("themes/".$this->currentTemplate."/css/authOperator.css");
		$this->addJsIncludes("js/ajaxPerfect.js");
		$this->addJsIncludes("js/auth.js");

		$auth = basic::load("auth","core");
		$auth->setToken();      // if it's not setting it - it's probably cz we have dbUi/error alert
		$this->allowCaptcha         = basic::$cfg['auth']['login']['allowCaptcha'];
		$this->captchaActiveAfter   = basic::$cfg['auth']['login']['captchaActiveAfter'];
		$this->captchaActiveAfterCS = $auth->getCookieNow($name = "loginAttempts");
		$this->view->operatorLogin  = true;          // option 1: $this->operatorLogin
		$this->set("operatorLogin",true);           // option 2: $operatorLogin

		if($this->allowCaptcha==1) {
			if($this->captchaActiveAfter<=$this->captchaActiveAfterCS) {
				$this->view->captchaShow = true;
			}
			else {
				$this->view->captchaShow = false;
			}
		}
		else {
			$this->view->captchaShow = false;
		}

		$this->view->authFileName = "/".basic::$cfg['site']['directory']['main'].lang::getCurrentLanguageForUrls()."sil/check";    // ?&chock=1

		$this->translations("login");    // load the text translations file

		$this->view->loggedIn      = $auth->checkIfLogged();
		$this->view->currentAction = "login";

		if($this->view->loggedIn!==false) {
			$userId               = $auth->getUserLoggedUserId();
			$this->view->userInfo = $this->operatorsModel->getUserInfo($userId)[0];
		}
	}
}
