<?php

/*************************************************************
 * Server load controller class
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/
class serverLoadController extends operatorsController {

	public $showCpuLoad;
	public $os;

	/**
	 * Initialize the required classes and variables
	 */
	public function init() {

		if(!class_exists('COM')) {
			$this->cancelViewExecution();

			if(myHelpers::isEnv($env = "dev")) {
				$notif = basic::load("notif","core");
				$notif->genNotifByNum("operators",$num = 76001,"ServerLoad");
			}
		}
		else {
			$this->varibles();
		}
	}

	public function varibles() {

// The Number Of Seconds The Script Tries To Connect
// To The Ports, You Can Use "." For A Part Of A Second.
		$portcheck = ".3";

// Bottom Copyright.
		$copyright = "2011 T2";

// The Server's Name, Leave Blank for The Servers Domain Name.
		$serverName = "";

// Leave Blank For Automatic OS Detection, Or Put
// In The Name You Want To Show Up For You'r Server OS.
		$customos = "";

// Here Is Where You Set The Ports,
// You Can Have as many as you want.

//Example:
//$name[99] = "Port Name";
//$port[99] = "Port #";
//$host[99] = ""; - Leave as is for the current domain, or enter a IP or Host, ex. "8.8.8.8"; or "google.com";

		$name[1] = "HTTP Web-Server";
		$port[1] = "80";
		$host[1] = "";

		$name[2] = "HTTPS Web-Server";
		$port[2] = "443";
		$host[2] = "";

		$name[3] = "MySQL-Server";
		$port[3] = "3306";
		$host[3] = "";

		$name[4] = "FTP-Server";
		$port[4] = "21";
		$host[4] = "";

		$name[5] = "POP3 Mail-Server";
		$port[5] = "110";
		$host[5] = "";

		$name[6] = "SMTP Mail-Server";
		$port[6] = "25";
		$host[6] = "";

		$name[7] = "DNS-Server";
		$port[7] = "53";
		$host[7] = "";

		$name[8] = "SSH-Server";
		$port[8] = "22";
		$host[8] = "";

// DO NOT EDIT BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING!!!!!!!!
		$arr = array(
			array($name[1],$port[1],$host[1]),
			array($name[2],$port[2],$host[2]),
			array($name[3],$port[3],$host[3]),
			array($name[4],$port[4],$host[4]),
			array($name[5],$port[5],$host[5]),
			array($name[6],$port[6],$host[6]),
			array(
				$name[7],
				$port[7],
				$host[7]
			),
			array($name[8],$port[8],$host[8]),
		);

///////////// Cpu

		if($serverName=="") {
			$theServerName = $_SERVER['SERVER_NAME'];
		}
		else {
			$theServerName = $serverName;
		}
		if($customos=="") {
			$osname = $this->checkos();
		}
		else {
			$this->os = "nocpu";
			$osname   = $customos;
		}
		if(php_sapi_name()=="apache2handler") {
			$httpapp = "Apache";
		}
		else {
			$httpapp = php_sapi_name();
		}

		if(PHP_OS=="WINNT") {
			$this->os = "windows";
			$osbuild  = php_uname('v');
		}
		elseif(PHP_OS=="Linux") {
			$this->os      = "linux";
			$goodforuptime = "1";
			$osbuild       = php_uname('r');
		}
		else {
			$this->os = "nocpu";
			$osbuild  = php_uname('r');
		}

///////////// Hdd

		$frei           = disk_free_space("../");
		$insgesamt      = disk_total_space("../");
		$belegt         = $insgesamt - $frei;
		$prozent_belegt = 100 * $belegt / $insgesamt;
		$diskspace      = $this->ZahlenFormatieren($insgesamt);
		$diskinuse      = $this->ZahlenFormatieren($belegt).'&nbsp;-&nbsp;'.round($prozent_belegt,"2").'%';
		$hddbarusage    = round($prozent_belegt,"2");
		$hddfreespace   = $this->ZahlenFormatieren($frei);

///////////// Os

		if($this->os=="windows") {    // disabling this lines will make the script load faster

			$syscpuload = "";
			$syscpuper  = "";
			/*			$wmi = new COM("Winmgmts://");
						$cpus = $wmi->execquery("SELECT * FROM Win32_Processor");
						foreach($cpus as $cpu) {
							$win_cpu_load = $cpu->loadpercentage;
						}
						$syscpuload = $win_cpu_load;
						$syscpuper = round($cpu->loadpercentage, "2");
						if($win_cpu_load=="") {
							$nocpushow = "1";
						}
						else {

						}*/
		}
		elseif($this->os=="linux") {
			##Time for my simple, new test code. I hope its correct... seems to be in tests...
			$lincpucrz     = exec("grep 'model name' /proc/cpuinfo | wc -l"); # How many CPU cores are reported
			$lincpuavgload = exec('cat /proc/loadavg'); # pull the load for the fun math

			##so if I am correct, when load avg = cores of CPU, thats 100% load core wide, SO that would mean that load / cores * 100 = load%
			##This is where testing gets fun! I will only use the first block for load finding, as it is the most updated, and not average load.
			$linloadper = ($lincpuavgload / $lincpucrz) * 100;

			##Sometimes CPU load goes OVER 100%, so lets fix that, shal we?
			if($linloadper>100) {
				$linloadpera = "100";
			}
			else {
				$linloadpera = $linloadper;
			}

			##Time to send output
			$syscpuload = $linloadpera;
			$syscpuper  = $linloadpera;

			##Bad old code, somthings wrong with it...
			/* function getStat($_statPath)
			{
			if(trim($_statPath) == '')
			{
			$_statPath = '/proc/stat';
			}

			ob_start();
			passthru('cat ' . $_statPath);
			$stat = ob_get_contents();
			ob_end_clean();


			if(substr($stat, 0, 3) == 'cpu')
			{
			$parts = explode(" ", preg_replace("!cpu +!", "", $stat));
			} else
			{
			return false;
			}

			$return = array();
			$return['user'] = $parts[0];
			$return['nice'] = $parts[1];
			$return['system'] = $parts[2];
			$return['idle'] = $parts[3];
			return $return;
			}

			function getCpuUsage($_statPath = '/proc/stat')
			{
			$time1 = getStat($_statPath);
			sleep(1);
			$time2 = getStat($_statPath);

			$delta = array();

			foreach($time1 as $k => $v)
			{
			$delta[$k] = $time2[$k] - $v;
			}

			$deltaTotal = array_sum($delta);
			$percentages = array();

			foreach($delta as $k => $v)
			{
			$percentages[$k] = round($v / $deltaTotal * 100, 2);
			}
			return $percentages;
			}
			$cpu = getCpuUsage();
			$cpulast = 100 - $cpu['idle'];
			$syscpuload = round($cpulast, "0");
			if($syscpuload == "")
			{
			$nocpushow = "1";
			} else
			{
			}
			*/
		}
		elseif($this->os=="nocpu") {
			$nocpushow = 1;
		}
		else {
			$nocpushow = 1;
		}

		if(!isset($nocpushow))
			$nocpushow = "";

		$showCpuLoad = "";
		if($nocpushow==1) {
			$showCpuLoad = "Unable to Detect Load";
			$showcpuper  = 100;
		}
		else {
			$showCpuLoad = $syscpuload;
			$showcpuper  = $syscpuper;
		}

///////////// Debug Page, handy stuff Here

		/*if(isset($_GET['debug']) && $_GET['debug'] == "all") {
		echo '<title>PHP Server Info DEBUG MODE | By ddggttff3</title>';
		echo '<center><p><b><font face="Verdana" color="#FF0000" size="6">Script Debug - Dump All Variables</font></b></p>';
		echo '<p><b><font face="Verdana" color="#000000" size="2">Raw output for your debugging needs....</font></b></p></center>';
		echo "Config File Readable: ";
		if(!is_readable('./config.php')) {
		echo "No";
		echo ' = <b>This may effect debug modes output, and leave many fields empty.</b><br />';
		} else {
		echo "Yes";
		echo '<br />';
		}
		echo "Page Title: " . $title . "<br />";
		echo "Port Timeout: " . $portcheck . "<br />";
		echo "Footer Text: " . $copyright . "<br />";
		echo "Custom Server Name: " . $serverName . "<br />";
		echo "Custom Server OS: " . $customos . "<br />";
		echo "Server Name: " . $theServerName . "<br />";
		echo "Server OS: " . $osname . "<br />";
		echo "Can Detect CPU Load: ";
		if($nocpushow == "1") {
		echo "No";
		echo "<br />";

		} else {
		echo "Yes";
		echo "<br />";
		}
		echo "Can Detect Uptime: ";
		if($goodforuptime == "1") {
		echo "Yes";
		echo "<br />";
		} else {
		echo "No";
		echo "<br />";
		}
		echo "Detected Server Domain: " . $_SERVER['SERVER_NAME'] . "<br />";
		echo "Script Code Date: 07/07/2011 4:37AM (-6:00) CST <br />";
		echo "HDD Space: " . $diskspace . "<br />";
		echo "HDD Space in Use: " . $diskinuse . "<br />";
		echo "HDD Percent Used: " . $hddbarusage . "<br />";
		echo "HDD Free Space: " . $hddfreespace . "<br />";
		echo "<br /><h3>Now lets run some code, and see what we get with debugging enabled in PHP.</h3><hr />";
		error_reporting(E_ALL);
		ini_set('display_errors', '1');
		}*/
// End Debug Page

		$this->view->showCpuLoad = $showCpuLoad;

///////////// Ram

		$this->view->os    = $this->os;
		$this->view->error = "";

		if($this->os=="windows") {
			error_reporting(E_ALL);
			$wmiq = new COM("Winmgmts://");
			$ossq = $wmiq->execquery("SELECT * FROM Win32_OperatingSystem");
			foreach($ossq as $osq) {
				$insgesamtq = $osq->TotalVisibleMemorySize;
				$freiq      = $osq->FreePhysicalMemory;
			}
			$belegtq         = $insgesamtq - $freiq;
			$prozent_belegtq = 100 * $belegtq / $insgesamtq;

			$this->view->memUsed    = self::lowerMemoryWindows($belegtq);
			$this->view->memUsedOf  = self::lowerMemoryWindows($insgesamtq);
			$this->view->memUsedBar = round($prozent_belegtq,"2");
			/*			echo"<p></p><b><u>Memory Load</u></b><p></p>";
						echo"Mem Used:&nbsp;".lowerMemoryWindows($belegtq)." of ".lowerMemoryWindows($insgesamtq)."<br>";
						echo"<p><img src=\"public/scripts/bar-load.php?rating=".round($prozent_belegtq,"2")."\" alt=\"\" border=\"0\"></p>";*/
		}
		elseif($this->os=="linux") {
			$mem = file_get_contents("/proc/meminfo");
			if(preg_match('/MemTotal\:\s+(\d+) kB/',$mem,$matches)) {
				$insgesamtq = $matches[1];
			}
			if(preg_match('/Buffers\:\s+(\d+) kB/',$mem,$matches)) {
				$buffertq = $matches[1];
			}
			if(preg_match('/Cached\:\s+(\d+) kB/',$mem,$matches)) {
				$cachedamtq = $matches[1];
			}
			unset($matches);
			if(preg_match('/MemFree\:\s+(\d+) kB/',$mem,$matches)) {
				$freiq = $matches[1];
			}
			$Used            = $insgesamtq - $freiq - $cachedamtq - $buffertq;
			$prozent_belegtq = 100 * $Used / $insgesamtq;

			$this->view->memUsed    = self::lowerMemoryLinux($Used);
			$this->view->memUsedOf  = self::lowerMemoryLinux($insgesamtq);
			$this->view->memUsedBar = round($prozent_belegtq,"2");
			/*			echo"<p></p><b><u>Memory Load</u></b><p></p>";
						echo"Mem Used:&nbsp;".lowerMemoryLinux($Used) . " of " . lowerMemoryLinux($insgesamtq)."<br>";
						echo"<p><img src=\"public/scripts/bar-load.php?rating=".round($prozent_belegtq,"2")."\" alt=\"\" border=\"0\"></p>";*/
		}
		elseif($this->os=="nocpu") {
			//	echo"";
		}
		else {
			//	echo"Memory Load:&nbsp;There Was An Error<br>";
			$this->view->error = "Memory Load:&nbsp;There Was An Error<br>";
		}

		$memlimit = ini_get('memory_limit');
		$memnow   = round(memory_get_usage() / 1024 / 1024,2)."M";
		$membar   = 100 * $memnow / $memlimit;

		$this->view->memUsageNow   = $memnow;
		$this->view->memUsageLimit = $memlimit;
		$this->view->memUsageBar   = round($membar,"2");
		$this->view->diskInUse     = $diskinuse;
		$this->view->diskUsage     = $hddbarusage;
		$this->view->diskSpace     = $diskspace;
		$this->view->DiskFree      = $hddfreespace;

		/*		echo"Mem Usage:&nbsp;$memnow of $memlimit<br>";
				echo"<p><img src=\"public/scripts/bar-load.php?rating=".round($membar,"2")."\" alt=\"\" border=\"0\"></p>";

				echo"<p></p><b><u>Server Space</u></b><p></p>";
				echo"In Use:&nbsp;$diskinuse<br>";
				echo"<p><img src=\"public/scripts/bar-load.php?rating=$hddbarusage\" alt=\"\" border=\"0\"></p>";
				echo"Disk Space:&nbsp;$diskspace<br>";
				echo"Free Space:&nbsp;$hddfreespace<br>";*/

///////////// Uptime

		$this->view->timeZone = "";
		if(ini_get('date.timezone')) {
			$this->view->timeZone = ini_get('date.timezone');
		}
		$this->view->serverDate = date("d M Y");
		$this->view->serverTime = date("H:i:s");

		/*		echo"<br><p><b><u><a class=\"toggle\" name=\"ServerUptime\" title=\""._EXPANDORFOLD."\">Server Uptime</a></u></b></p>";
				echo"<div id=\"expander-ServerUptime\" style=\"display:none;\">";

		//	echo"<br><p></p><b><u>Server Uptime</u></b><p></p>";
				if(ini_get('date.timezone')) {
					echo"Server TimeZone:&nbsp;".ini_get('date.timezone')."<br>";
				}
				echo"Server Date:&nbsp;".date("d M Y")."<br>";
				echo"Server Time:&nbsp;".date("H:i:s")."<br>";*/

		if($this->os=="windows") {

			if(!isset($goodforuptime))
				$goodforuptime = "";

			if($goodforuptime==1) {
				$pagefile = 'c:\pagefile.sys';
				function ifif($value,$true,$false) {

					if($value==0) {
						return $false;
					}
					else {
						return $true;
					}
				}

				$upsince = filemtime($pagefile);
				$gettime = (time() - filemtime($pagefile));
				$days    = floor($gettime / (24 * 3600));
				$gettime = $gettime - ($days * (24 * 3600));
				$hours   = floor($gettime / (3600));
				$gettime = $gettime - ($hours * (3600));
				$minutes = floor($gettime / (60));
				$gettime = $gettime - ($minutes * 60);
				$seconds = $gettime;
				$days    = ifif($days!=1,$days.' Days',$days.' Day');
				$hours   = ifif($hours!=1,$hours.' Hours',$hours.' Hour');
				$minutes = ifif($minutes!=1,$minutes.' Minutes',$minutes.' Minute');
				$seconds = ifif($seconds!=1,$seconds.' Seconds',$seconds.' Second');
				if($days==0) {
					$days = "";
				}
				if($hours==0) {
					$hours = "";
				}
				if($minutes==0) {
					$minutes = "";
				}
				if($seconds==0) {
					$seconds = "";
				}

				echo ''.$days.' '.$hours.' '.$minutes.' '.$seconds;
				echo 'Up since: '.date('F jS, Y. h:i A',$upsince);
			}
			else {
			}
		}

		if($this->os=="linux") {
			/*
			///////////// New method of uptime

				function format_uptime($seconds) {
					$secs = intval($seconds % 60);
					$mins = intval($seconds / 60 % 60);
					$hours = intval($seconds / 3600 % 24);
					$days = intval($seconds / 86400);

					if($days > 0) {
						$uptimeString .= $days;
						$uptimeString .= (($days == 1) ? " Day" : " Days");
					}
					if($hours > 0) {
						$uptimeString .= (($days > 0) ? " " : "") . $hours;
						$uptimeString .= (($hours == 1) ? " Hour" : " Hours");
					}
					if($mins > 0) {
						$uptimeString .= (($days > 0 || $hours > 0) ? " " : "") . $mins;
						$uptimeString .= (($mins == 1) ? " Minute" : " Minutes");
					}
					if($secs > 0) {
						$uptimeString .= (($days > 0 || $hours > 0 || $mins > 0) ? " " : "") . $secs;
						$uptimeString .= (($secs == 1) ? " Second" : " Seconds");
					}
					return $uptimeString;
				}

				$uptime = exec("cat /proc/uptime");
				$uptime = split(" ",$uptime);
				$uptimeSecs = $uptime[0];
				$staticUptime = format_uptime($uptimeSecs);

				echo"Server Uptime:&nbsp;$staticUptime<br>";
			*/

///////////// Old method of uptime

			//GET SERVER LOADS
			$loadresult = @exec('uptime');
			preg_match("/averages?: ([0-9\.]+),[\s]+([0-9\.]+),[\s]+([0-9\.]+)/",$loadresult,$avgs);

			//GET SERVER UPTIME
			$uptime       = explode('up',$loadresult);
			$uptime       = explode(',',$uptime[1]);
			$uptime       = $uptime[0].'&nbsp;+&nbsp;'.$uptime[1].'&nbsp;Hrs';
			$serverUptime = "Server Load Averages:&nbsp;$avgs[1],$avgs[2],$avgs[3]\n";
			$serverUptime .= "<br>Server Uptime:&nbsp;$uptime";
			//	echo"Server Uptime:&nbsp;$uptime<br>";
		}

		//	echo"<br></div>";	// closes uptime

		$this->view->serverName   = $theServerName;
		$this->view->remoteAddres = $_SERVER['REMOTE_ADDR'];
		$this->view->os           = $osname;
		$this->view->osBuilt      = $osbuild;
		$this->view->osType       = php_uname('m');
		$this->view->phpVer       = phpversion();
		$this->view->httpApp      = $httpapp;

//	echo"<p></p><b><u>System Info</u></b><p></p>";
		/*		echo"<p><b><u><a class=\"toggle\" name=\"SystemInfo\" title=\""._EXPANDORFOLD."\">Server: $theServerName</a></u></b></p>";
				echo"<div id=\"expander-SystemInfo\" style=\"display:none;\">";
				echo"Your IP:&nbsp;".$_SERVER['REMOTE_ADDR']."<br>";
				echo"OS:&nbsp;$osname<br>";
				echo"Build:&nbsp;$osbuild<br>";
				echo"OS Type:&nbsp;".php_uname('m')."<br>";
				echo"PHP Ver:&nbsp;".phpversion()."<br>";
				echo"HTTP App:&nbsp;$httpapp<br>";
				echo"</div>";*/

		/*
			echo"<br><p><b><u>Server ports</u></b></p>";

		foreach($arr as $c) {
			if($c[2] == "") {
				$c[2] = $_SERVER['SERVER_NAME'];
			}
			else {
			}
			if(@fsockopen($c[2], $c[1], $errno, $errstr, $portcheck)) {
				$img = "images/v.gif";
			}
			else {
				$img = "images/x-selected.gif";
			}
			echo"<p style=\"margin:1px;\" align=\"center\">$c[0]&nbsp;&nbsp;<img src=\"$img\" style=\"vertical-align:text-bottom;\" border=\"0\" width=\"14\" height=\"14\" alt=\"\">&nbsp;&nbsp;<span style=\"width:120px;\">$c[1]</span></p>";
			flush();
		}

		// taking to much time to run, it's slowing the entire site
		*/

		//	themesidebox($title="dddd",$content=$content,$num);
		//	echo $content;

	}

	public function checkos() {

		if(substr(PHP_OS,0,3)=="WIN") {
			$osType   = $this->winosname();
			$osbuild  = php_uname('v');
			$this->os = "windows";
		}
		if(PHP_OS=="FreeBSD") {
			$this->os = "nocpu";
			$osType   = "FreeBSD";
			$osbuild  = php_uname('r');
		}
		if(PHP_OS=="Darwin") {
			$this->os = "nocpu";
			$osType   = "Apple OS X";
			$osbuild  = php_uname('r');
		}
		if(PHP_OS=="Linux") {
			$centoscheck = exec("cat /etc/redhat-release");
			$checktime   = strpos($centoscheck,"CentOS");
			if($checktime==true) {
				$this->os = "linux";
				$osType   = "CentOS";
				$osbuild  = php_uname('r');
			}
			else {
				$this->os = "linux";
				$osType   = "Linux";
				$osbuild  = php_uname('r');
			}
		}
		else {
			$this->os = "nocpu";
			$osType   = "Unknown OS";
			$osbuild  = php_uname('r');
		}

		return $osType;
	}

	public function winosname() {

		$wUnameB  = php_uname("v");
		$wUnameBM = php_uname("r");
		$wUnameB  = preg_replace("/build /","",$wUnameB);
		if($wUnameBM=="5.0" && ($wUnameB=="2195")) {
			$wVer          = "Windows 2000";
			$goodforuptime = "1";
		}
		if($wUnameBM=="5.1" && ($wUnameB=="2600")) {
			$wVer          = "Windows XP";
			$goodforuptime = "1";
		}
		if($wUnameBM=="5.2" && ($wUnameB=="3790")) {
			$wVer          = "Windows Server 2003";
			$goodforuptime = "1";
		}
		if($wUnameBM=="6.0" && (php_uname("v")=="build 6000")) {
			$wVer          = "Windows Vista";
			$goodforuptime = "1";
		}
		if($wUnameBM=="6.0" && (php_uname("v")=="build 6001")) {
			$wVer          = "Windows Vista SP1";
			$goodforuptime = "1";
		}
		if($wUnameBM=="6.0" && (php_uname("v")=="build 6002")) {
			$wVer          = "Windows Vista SP2";
			$goodforuptime = "1";
		}
		if($wUnameBM=="6.1" && (php_uname("v")=="build 7600")) {
			$wVer          = "Windows 7 / Server 2008 R2";
			$goodforuptime = "0";
		}

		if(!isset($wVer))
			$wVer = "";

		return $wVer;

		return $goodforuptime;
	}

	public function ZahlenFormatieren($Wert) {

		if($Wert>1099511627776) {
			$Wert = number_format($Wert / 1099511627776,2,".",",")."TB";
		}
		elseif($Wert>1073741824) {
			$Wert = number_format($Wert / 1073741824,2,".",",")."GB";
		}
		elseif($Wert>1048576) {
			$Wert = number_format($Wert / 1048576,2,".",",")."MB";
		}
		elseif($Wert>1024) {
			$Wert = number_format($Wert / 1024,2,".",",")."kB";
		}
		else {
			$Wert = number_format($Wert,2,".",",")."Bytes";
		}

		return $Wert;
	}

	public function lowerMemoryWindows($Wertq) {

		if($Wertq>1073741824) {
			$Wertq = number_format($Wertq / 1073741824,2,".",",")."Tb";
		}
		elseif($Wertq>1048576) {
			$Wertq = number_format($Wertq / 1048576,2,".",",")."Gb";
		}
		elseif($Wertq>1024) {
			$Wertq = number_format($Wertq / 1024,2,".",",")."Mb";
		}
		else {
			$Wertq = number_format(floatval($Wertq),2,".",",")."Kb";
		}

		return $Wertq;
	}

	public function lowerMemoryLinux($Wertq) {

		if($Wertq>1073741824) {
			$Wertq = number_format($Wertq / 1073741824,2,".",",")."Tb";
		}
		elseif($Wertq>1048576) {
			$Wertq = number_format($Wertq / 1048576,2,".",",")."Gb";
		}
		elseif($Wertq>1024) {
			$Wertq = number_format($Wertq / 1024,2,".",",")."Mb";
		}
		else {
			$Wertq = number_format($Wertq,2,".",",")." Kb";
		}

		return $Wertq;
	}
}
