<?php

/*************************************************************
 * Required parameters for the Error Control system
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/

/**
 * Allow FW's error report?
 * if disabled, errorReportUi and logs will be disabled, but dbUi can be active
 */
$cfg['errorControl']['allow'] = 1;

/**
 * Allow error report ui to be shown?
 */
$cfg['errorControl']['errorReportUi']['allow']     = 1;      // 0 - nope, 1 - sure (dev env + dev users), 2 - sure (only dev env)
$cfg['errorControl']['errorReportUi']['afterHtml'] = 1;      // 0 - insert $errorControlContainer before html tag (will allow the ui to show if fatal error occurred), 1 - insert $errorControlContainer after html tag

/**
 * Allow db ui to be shown?
 */
$cfg['errorControl']['dbUi']['allow']      = 1;              // 0 - nope, 1 - sure (dev env + dev users), 2 - sure (only dev env)
$cfg['errorControl']['dbUi']['dbUiOnPost'] = 1;              // 0 - will be disabled on html post, 1 - will allow even on html post
$cfg['errorControl']['dbUi']['afterHtml']  = 1;              // 0 - insert $dbInformantContainer before html tag (will allow the ui to show if fatal error occurred), 1 - insert $dbInformantContainer after html tag
$cfg['errorControl']['dbUi']['allowShowOnPage'] = 1;         // 0 - will be disabled , 1 - will allow to show on page location

/**
 * Error log - active methods
 * Error log - errors locations
 * ** if we want the original php settings, this settings can be removed
 */
$cfg['errorControl']['fatalErrors']['logMethod']   = array(
	"file",
	"db",
	"mail"
);        // file/fileJson/db/mail	// if no db is set mail will be send on every error without sendErrorByMailInterval
$cfg['errorControl']['fatalErrors']['logLocation'] = 'php-error-fatal.log';    // if missing, php_error_log or whatever is on php.ini will be written

$cfg['errorControl']['nonFatalErrors']['logMethod']   = array(
	"file",
	"db"
);        // file/fileJson/db/mail	// if no db is set mail will be send on every error without sendErrorByMailInterval
$cfg['errorControl']['nonFatalErrors']['logLocation'] = 'php-error-nonFatal.log';    // if missing, php_error_log or whatever is on php.ini will be written

$cfg['errorControl']['dbErrors']['logMethod']   = array(
	"file",
	"db",
	"mail"
);        // file/fileJson/db/mail	// if no db is set mail will be send on every error without sendErrorByMailInterval
$cfg['errorControl']['dbErrors']['logLocation'] = 'php-error-db.log';

$cfg['errorControl']['dbQueries']['logMethod']   = array("file");                    // file/fileJson
$cfg['errorControl']['dbQueries']['logLocation'] = 'php-mysql-queries.log';

/**
 * Errors will be sent by mail to the admin, this is the error interval
 */
$cfg['errorControl']['sendErrorByMailInterval'] = 60 * 5;

