<?php

/*************************************************************
 * Required parameters for the Log system
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/
/**
 * Allow info Ui
 */
$cfg['log']['infoUi']['allow'] = 1;         // 0 - nope, 1 - sure (dev env + dev users), 2 - sure (only dev env)

/**
 * Allow info Ui on post
 */
$cfg['log']['infoUi']['infoUiOnPost'] = 1;  // 0 - will be disabled on html post, 1 - will allow even on html post

/**
 * Insert info Ui after html tag
 */
$cfg['log']['infoUi']['afterHtml'] = 1;     // 0 - insert $infoUiContainer before html tag, 1 - insert $infoUiContainer after html tag open

/**
 * Log info Ui functions
 */
$cfg['log']['infoUi']['functions'] = array(
	array(
		"name"      => "server",
		"output"    => $_SERVER,
		"logToFile" => false,
	),
	array(
		"name"      => "files",
		"output"    => $_FILES,
		"logToFile" => false,
	),
	array(
		"name"      => "get",
		"output"    => $_GET,
		"logToFile" => true,
	),
	array(
		"name"      => "post",
		"output"    => $_POST,
		"logToFile" => true,
	),
	array(
		"name"      => "request",
		"output"    => $_REQUEST,
		"logToFile" => false,
	),
	array(
		"name"      => "cookie",
		"output"    => $_COOKIE,
		"logToFile" => true,
	),
	array(
		"name"      => "session",
		"output"    => $_SESSION,
		"logToFile" => false,
	),
	array(
		"name"      => "includedFiles",
		"output"    => get_included_files(),
		"logToFile" => false,
	),
	array(
		"name"      => "definedConstants",
		"output"    => get_defined_constants(true)['user'],
		"logToFile" => false,
	),
	array(
		"name"      => "loadedExtensions",
		"output"    => get_loaded_extensions(),
		"logToFile" => false,
	),
	/*	array(
			"name"      => "getDefinedVars",
			"output"    => get_defined_vars(),
			"logToFile" => false,
		),*/
);

/**
 * Log default method
 */
$cfg['log']['default'] = "file";            // file/fileJson/db/mail

/**
 * Log default method
 */
$cfg['log']['directory'] = IMPERMANENTPATH.DS."logs";            // logs directory

/**
 * Error log date+Time format
 */
$cfg['log']['dateFormat'] = "d/m/Y";
$cfg['log']['timeFormat'] = 'H:i:s \G\M\T P';