<?php

/*************************************************************
 * Required parameters for the Alert system
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/

// alerts number that ends with the numbers:
// 1 - 0-249	- green - notification only
// 2 - 250-499	- yellow - db/mySql alerts
// 3 - 500-749	- orange - alert that is not stacking the system
// 4 - 750-999	- red - alert that can stack the system

$cfg['notif']['allow'] = 1;                 // 0 - block alerts even on dev user, 1 - enabled, 2 - enabled, but block only core errors even on dev user

$cfg['notif']['afterHtml'] = 1;             // 0 - insert $uiContainer before html tag (will allow the ui to show if fatal error occurred), 1 - insert $uiContainer after html tag

$cfg['notif']['loadMethod'] = "array";	    // array - a php file that holds the translations / xml - an xml file
// in the future also db/mySql will be available

$cfg['notif']['type'][1] = "green";	        // notification only
$cfg['notif']['type'][2] = "orange";	    // alert that is not stacking the system
$cfg['notif']['type'][3] = "red";		    // alert that can stack the system - or acute problem
$cfg['notif']['type'][4] = "blue";	        // db/mySql alerts
$cfg['notif']['type'][5] = "purple";	    // connection and outside connection problems - like: no connection/mail

$cfg['notif']['interval'] = array(1=>5000,2=>3000,3=>12000,4=>15000,5=>25000);	// disable/enable alerts on the system and their life span in milliseconds
$cfg['notif']['calledInfo'] = 1;			// alerts adds: file address - for the file who called the alert (only in dev environment/dev user)

/**
 * Log file will be saved on alertType levels
 */
$cfg['notif']['logNotifs']['logMethod'][1] = array("file","db");			    // file/fileJson/db/mail
$cfg['notif']['logNotifs']['logLocation'][1] = 'notifs-type-1.log';

$cfg['notif']['logNotifs']['logMethod'][2] = array("file","db");			    // file/fileJson/db/mail
$cfg['notif']['logNotifs']['logLocation'][2] = 'notifs-type-2.log';

$cfg['notif']['logNotifs']['logMethod'][3] = array("file","db");			    // file/fileJson/db/mail
$cfg['notif']['logNotifs']['logLocation'][3] = 'notifs-type-3.log';

$cfg['notif']['logNotifs']['logMethod'][4] = array("file","db","mail");			// file/fileJson/db/mail
$cfg['notif']['logNotifs']['logLocation'][4] = 'notifs-type-4.log';

$cfg['notif']['logNotifs']['logMethod'][5] = array("file","db","mail");			// file/fileJson/db/mail
$cfg['notif']['logNotifs']['logLocation'][5] = 'notifs-type-5.log';

/**
 * Alerts will be sent by mail to the admin, this is the error interval
 */
$cfg['notif']['sendErrorByMailInterval'] = 60*5;

