<?php

/*************************************************************
 * Advanced system class for files
 * - configure the db handling system
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class advanced extends controllerWarehouse {

  use advancedTrait;

  private $advancedTempDirectory;
  private $advancedDataDirectory;
  private $advancedArchiveDataDirectory;
  private $advancedForMysql;
  private $advancedForFiles;
  protected $notif;

  /**
   * Constructor for advanced
   */
  function __construct() {

    $this->advancedForMysql = new advancedForMysql();
//  $this->advancedForFiles = new advancedForFiles();

//  basic::loadCfg("advancedConfig");
  }

  public function getAllData($blueprintName) {

    $getData = $this->advancedForMysql->getAllDataFromBlueprint($this->pdoHelper,$blueprintName);

    return $getData;
  }

  public function getSingleData($blueprintName,$leadId) {

    $getData = $this->advancedForMysql->getSingleDataFromBlueprint($this->pdoHelper,$blueprintName,$leadId);

    return $getData;
  }

  public function getSearchedData($blueprintName,$where,$orderBy = "",$limit = "") {

    $getData = $this->advancedForMysql->getSearchedDataFromBlueprint($this->pdoHelper,$blueprintName,$where,$orderBy,$limit);

    return $getData;
  }

  public function installSystemTables() {

    $testNewDirectory = ROOT.DS.'impermanent'.DS."installMarked";
    $dbMarkFile    = $testNewDirectory.DS."dbMarkFile.log";

    if(!file_exists($dbMarkFile)) {
        $this->notif = basic::load("notif","core");
        $this->notif->loadNotifs($file = "advanced");
        $this->advancedForFiles = new advancedForFiles();
        $this->model            = new advancedBlueprintsModel($this->pdoHelper);

        $createdNewDatabase = $this->creatingNewDatabase(basic::getConfig("db","main","database"));
        $systemFiles = $this->advancedForFiles->getBlueprintsFromDir("system");

        if(!empty($systemFiles)) {
          foreach($systemFiles as $systemFile) {
            $this->blueprintName = $systemFile["filename"];
            $advancedData = $this->advancedForFiles->loadSystemBlueprint($this->blueprintName);
            $createdBlueprints[] = $this->creatingNewBlueprint($advancedData);
          }

          if($createdNewDatabase) {
            $this->notif->genNotifByNum("advanced",9060,basic::getConfig("db","main","database"));
          }
          if(!empty($createdBlueprints)) {
            $this->notif->genNotifByNum("advanced",9062);
          }
        }
        else {
          echo"-- Directory: ".$this->advancedForFiles->advancedsystemDirectory." is empty! please add the files back.";
          die();
        }

      file_put_contents($dbMarkFile,'-- Mysql db installed A ok - on "'.basic::getConfig("db","main","database").'" database. Please don\'t delete this file, deletion will cause another function check.
-- For security reasons please add this code into your nginx conf (if nginx server):
  location ~\.(ini|log|conf|txt|pem|key|ht)$ {
	   deny all;
	   error_page 403 =404 /;
	}
	  
-- Or add .htaccess file into this directory (if apache server):
  Deny from all

-- Or alternatively just delete the database name from this file (this is done only once).
  ');
    }
  }
}

