<?php

/*************************************************************
 * User class
 * - all functions about users info
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class user {

	private $db;

	/**
	 * Constructor for user
	 */
	public function __construct() {

    if(basic::getConfig("db","main","activate")==true) {
      $this->db = basic::load(basic::getConfig("db","main","adapter"),'core/adapters');
    }
	}

	/**
	 * Get all users details
	 * @return array $checkData - containing: userName, email, phone, firstName, lastName
	 */
	public function getAllUsersDetails() {

		$checkData = $this->db->find($table = basic::getConfig("db","main","tablePrefix")."users",$col = array(
			"userName",
			"email",
			"phone",
			"firstName",
			"lastName",
			"subscribes",
			"userAuthLevel",
			"isActive",
			"isDeleted",
			"lastSuccessLogin",
			"lastFailedLogin",
			"lastPasswordReset",
		));

		if($checkData) {
			return $checkData;
		}
		else {
			return false;
		}
	}

	/**
	 * Get user details
	 * @param  string $userId - user id
	 * @return array $checkData - containing: userName, email, phone, firstName, lastName
	 */
	public function getUserDetails($userId) {

		$checkData = $this->db->find($table = basic::getConfig("db","main","tablePrefix")."users",$col = array(
			"leadId",
			"userName",
			"email",
			"phone",
			"firstName",
			"lastName",
			"subscribes",
			"userAuthLevel",
			"isActive",
			"isDeleted",
			"lastSuccessLogin",
			"lastFailedLogin",
			"lastPasswordReset",
		),$where = array("leadId" => $userId));

		if($checkData) {
			return $checkData[0];
		}
		else {
			return false;
		}
	}
}

