<?php

/*************************************************************
 * Bread crumbs class
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class breadCrumbs {

  /**
   * Bread crumbs
   * @param bool|false|array $crumbs - array of crumbs
   * @param string $leadingText - if we want to put leading text
   * @param string $separator - separator text
   * @param bool $static - if the links will be static and will/wont be in a chain
   * @param string $homeName
   * @return array
   */
  static public function getCrumbs($crumbs = false,$leadingText = "You are here: ",$separator = " &raquo; ",$static = false,$homeName = "Home") {

    $protocol = strtolower(substr($_SERVER["SERVER_PROTOCOL"],0,strpos($_SERVER["SERVER_PROTOCOL"],"/")))."://";
    $domain   = $protocol.$_SERVER['HTTP_HOST'];
    if(!$crumbs) {
      $crumbs = explode("/",$_SERVER["REQUEST_URI"]);
    }

    $crumbsTemp    = array_filter($crumbs);                                    // get all vars and skip the empty ones
    $crumbs        = array();
    $tempLink      = "";
    $lastKey       = key(array_slice($crumbsTemp,-1,1,true));
    $separatorTemp = $separator;
    foreach($crumbsTemp as $key => $value) {
      if($key==$lastKey) {
        $separatorTemp = "";
      }
      if(count($crumbsTemp)!=count($crumbsTemp,COUNT_RECURSIVE)) {        // if we have multidimensional array
        (is_numeric($key)) ? $crumbs[$key]['name'] = $value['name'] : $crumbs[$key]['name'] = $key;
        $tempLink                  = $tempLink."/".$value['link'];
        $crumbs[$key]['link']      = $domain.$tempLink;
        $crumbs[$key]['title']     = $value['title'];
        $crumbs[$key]['seporator'] = $separatorTemp;
        continue;
      }
      (is_numeric($key)) ? $crumbs[$key]['name'] = $value : $crumbs[$key]['name'] = $key;
      if($static==true) {
        $tempLink = "";
      }

      $tempLink                  = $tempLink."/".$value;
      $crumbs[$key]['link']      = $domain.$tempLink;
      $crumbs[$key]['title']     = "";
      $crumbs[$key]['separator'] = $separatorTemp;
    }
    $domainArray = array("name" => $homeName,"link" => $domain,"title" => "","separator" => $separator);
    array_unshift($crumbs,$domainArray);

    $crumbs['leadingText'] = $leadingText;
    $crumbs['domain']      = $domain;

    return $crumbs;
  }
}

