<?php

/*************************************************************
 * Includes
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/

function LogSuperglobals($content) {

	$g  = "";
	$p  = "";
	$f  = "";
	$s  = "";
	$c  = "";
	$cc = "";

	if(isset($_GET))
		$g = print_r($_GET,true);
	if(isset($_POST))
		$p = print_r($_POST,true);
	if(isset($_FILES))
		$f = print_r($_FILES,true);
	if(isset($_SESSION))
		$s = print_r($_SESSION,true);
	if(isset($_COOKIE))
		$c = print_r($_COOKIE,true);
	if(isset($content))
		$cc = print_r($content,true);

	$txt = '';
	$txt .= PHP_EOL.' TIME: '.date('Y-m-d H:i:s',time());
	$txt .= PHP_EOL.' GET: '.$g;
	$txt .= PHP_EOL.' POST: '.$p;
	$txt .= PHP_EOL.' FILES: '.$f;
	$txt .= PHP_EOL.' SESSION: '.$s;
	$txt .= PHP_EOL.' COOKIE: '.$c;
	$txt .= PHP_EOL.' content: '.$cc;

	file_put_contents('requests.txt',$txt);
}

/**
 * @param $content
 * @param bool $title - will show it on "Info screen"
 * @param bool $align
 * @param bool $output
 * @param bool $logToFile - will log the content on a log file
 * @param bool $backtrace
 */
function p($content,$title = false,$align = false,$output = true,$logToFile = true,$backtrace = false) {

	$backtraceKey = 1;

//	if(empty($content) && $content !== "0") $content = "undefined var";
	printIt($content,$title,$align,$output,$logToFile,$backtraceKey);
}

/**
 * @param $content
 * @param bool $title
 * @param bool $align
 * @param bool $output
 * @param bool $logOnFile
 * @param int $backtraceKey
 * @return string
 */
function printIt($content,$title = false,$align = false,$output = true,$logOnFile = true,$backtraceKey = 0) {

	global $didStyleJs;

//	if(empty($content) && $content !== "0") $content = "Undefined Var";

	debugOnConsole($content);
//	LogSuperglobals($content);

	$trace = debug_backtrace();
	$vLine = file(__FILE__);
	$fLine = $vLine[$trace[0]['line'] - 1];
  $originalVar = "";
	preg_match("#\\$(\w+)#",$fLine,$originalVar);
	if(isset($originalVar[1])) {
		$originalVar = $originalVar[1];
	}
	$printItFirst   = "";
	$printItSecond  = "";
	$randomNumber   = rand(10000,99999);
	$debug          = 1;
	$hideFromScreen = "";

  if($title) {
    $hideFromScreen = "style='display: none;'";
  }

	require_once(LABYARDPATH."mvc".DS."router".".class.php");
	if(router::isLocalhost() || $debug==1) {
		$style = "<link rel=\"stylesheet\" property=\"stylesheet\" href=\"".router::$localHostNextDir."/public/css/printIt.css\" type=\"text/css\" media=\"all\">";

		$js = "<script src=\"".router::$localHostNextDir."/public/js/printIt.js\" type=\"text/javascript\"></script>";

		$printItFirst = "<div class=\"printIt\">";

    $alignIt = "";
		if($align=="center")
			$alignIt = "50%";
		if($align=="right")
			$alignIt = "100%";
		if($align=="left")
			$alignIt = "0%";
		if($align) {
			$printItFirst .= "<div class=\"printIt-container\" style=\"left:".$alignIt.";\">";
			$printItFirst .= "<div class=\"printIt-subContainer\" style=\"left:-".$alignIt.";\">";
		}
		// &#8212; &#8212;

    $countChars = 0;
    if(!is_array($originalVar)) {
      $countChars = strlen($originalVar);
    }

		$specialChars = 25 - $countChars;
    $originalVar = ($originalVar!="didStyleJs" && $originalVar!="js") ? $originalVar : "";
    $originalVar = !empty($originalVar) ? $originalVar : "";

		$printItFirst .= "<pre id=\"PrintIt-".$randomNumber."\" ".$hideFromScreen." dir=\"ltr\" class=\"printIt-pre\">||&#8212;&#8212;&#8212;&#8212;&#8212;T2:&nbsp;$".$originalVar.str_repeat("&#8212;",$specialChars)."||<br>";

		if($title) {
			$printItFirst .= "||&nbsp;&nbsp;&nbsp;Print title: <b><xmp class=\"printIt-xmp printIt-title\">".$title."</xmp></b><br>";
			$printItFirst .= "||".str_repeat("&#8212;",35)."||<br>";
		}
		if(is_array($content) || is_object($content)) {
			$printItSecond .= "</div>&nbsp;&nbsp;&nbsp;&nbsp;<span></span><b>)</b>";
		}

		$backtrace = debug_backtrace();
		$lastFile = $backtrace[$backtraceKey]['file']; // printIt was called from here
		$lastLine = $backtrace[$backtraceKey]['line'];

		$printItSecond .= "<br><div class=\"printIt-lastUrl\">".$lastFile." On Line ".$lastLine."</div>||".str_repeat("&#8212;",2).date('Y-m-d H:i:s',time())."&#8212;&#8212;<div class=\"printIt-inline\"><a href=\"javascript:\" class=\"printIt-options printIt-urlToggle-".$randomNumber."\" title=\"From where printIt called from\">UL</a>&#8212;<a href=\"javascript:\" class=\"printIt-options printIt-typeLengthToggle-".$randomNumber."\" title=\"Length toggle\">LT</a>&#8212;<a href=\"javascript:\" class=\"printIt-options printIt-spacerToggle-".$randomNumber."\" title=\"Spacer toggle\">ST</a>&#8212;<a href=\"javascript:\" class=\"printIt-options printIt-newWindow-".$randomNumber."\" title=\"Open in a new window\">O</a>".str_repeat("&#8212;",2)."||</div><br>";

		$printItSecond .= "</pre>";
		$printItSecond .= "</div>";

		if($align) {
			$printItSecond .= "</div>";
			$printItSecond .= "</div>";
			$printItSecond .= "<div class=\"printIt-clear\"></div>";
		}

		if($logOnFile!==false) {
      $title = $title ? $title : "someLog";
			log::logToFile("printIt".DS.$title,print_r($content,true));
		}

		if($output==true) {
			if(!$didStyleJs) {
				echo $style;
				echo $js;
				$didStyleJs = 1;
			}
			echo $printItFirst;

			$count = (empty($content) || !is_array($content)) ? 0 : count($content);

			if($count<9000) {   // if the count is big we will have memory leak and breakdown - so we stop it here
				echo listArrayRecursive($content,null,1,null,$randomNumber);
			}

			echo $printItSecond;
		}
		else {
			return $style.$js.$printItFirst.listArrayRecursive($content,$output = false,1,null,$randomNumber).$printItSecond;
		}
	}
	else {
		$printIt = "Data Log available only on LOCALHOST";
		if($output==true) {
			echo $printIt;
		}
		else {
			return $printIt;
		}
	}
}

function objectToArray($data) {

	if(is_array($data) || is_object($data)) {
		$result = array();
		foreach($data as $key => $value) {
			$result[$key] = objectToArray($value);
		}

		return $result;
	}

	return $data;
}

function listArrayRecursive($content,$output = true,$indent = 1,$did = false,$randomNumber="") {

	$return = "";
	if(is_object($content)) {
		// $content = json_decode(json_encode($content),true); // sometimes making problems
		$content  = objectToArray($content);
		$isObject = true;
	} // if is object convert it to array
	$n = 0;

	/*    <a href="#" class="printIt-showHide">Array +</a>
	<div class="printIt-slidingDiv" style="display:none">
	Fill this space with really interesting content. 1
	</div>*/

	if(is_array($content)) {
		if($did==false) {
			$return = "(<span class=\"printIt-contentCount\">".count($content)."</span>)";
			if(!isset($isObject)) {
				$typeOfVar = "Array";
			}
			else {
				$typeOfVar = "Object";
			}
			$return .= "&nbsp;<b><a href=\"javascript:\" class=\"printIt-contentType printIt-showHide printIt-showHide-".$randomNumber."\">".$typeOfVar."&nbsp;-&nbsp;</a>(</b><br><div class=\"printIt-breaker\">";
		}
		++$n;
		foreach($content as $k => $v) {
			if(is_array($v) || is_object($v)) {
				$count       = count((array) $v);
				$numOfDigits = strlen($count);
				$return .= "(<span class=\"printIt-contentCount\">".$count."</span>)";
				for($i = 0; $i<$indent * (1 + $indent + $n) - ($numOfDigits - 1); $i++) {
					$return .= "&nbsp;";
				}
				if($indent==2) {
					$return .= "&nbsp;";
				}
				$return .= "[".$k."] : <b><a href=\"javascript:\" class=\"printIt-showHide printIt-showHide-".$randomNumber."\">Array&nbsp;-&nbsp;</a>(</b><br>";
				$return .= "<div class=\"printIt-slidingDiv\">";
				$return .= listArrayRecursive($v,$output = false,$indent + 1,$did = 1,$randomNumber);
				$return .= "</div>";
				if(is_array($content[$k])) {
					for($i = 0; $i<$indent * 10; $i++) {
						$return .= "&nbsp;";
					}
					$return .= "<b>)</b><br>";
				}
			}
			else {
				for($i = 0; $i<$indent * 6; $i++) {
					$return .= "&nbsp;";
				}

				$typeOfVar   = gettype($v);
				$lengthOfVar = strlen($v);

				$return .= "[<xmp class=\"printIt-xmp\">".$k."</xmp>]<div class=\"printIt-spacer\"></div>&nbsp;=><span class=\"printIt-typeLength\">&nbsp;$typeOfVar($lengthOfVar)</span>&nbsp;<xmp class=\"printIt-xmp\">".$v."</xmp><br>";
			}
		}
	}
	else {
		if(empty($content) && $content !== "0") {
			$return .= "&nbsp;&nbsp;&nbsp;x&nbsp;<span class=\"printIt-undefined\">Undefined Variable</span>&nbsp;x";
		}
		else {
			$typeOfVar   = gettype($content);
			$lengthOfVar = strlen($content);

			$return .= "[<xmp class=\"printIt-xmp\">".ucfirst($typeOfVar)."</xmp>]<div class=\"printIt-spacer\"></div>&nbsp;=><span class=\"printIt-typeLength\">&nbsp;$typeOfVar($lengthOfVar)</span>&nbsp;<xmp class=\"printIt-xmp\">".$content."</xmp>";
		}
	}
	if($output==true) {
		echo $return;
	}
	else {
		return $return;
	}
}

function debugOnConsole($data) {

	echo "<script>\r\n//<![CDATA[\r\nif(!console){var console={log:function(){}}}";
	$output = explode("\n",print_r($data,true));
	foreach($output as $line) {
		if(trim($line)) {
			$line = addslashes($line);
			echo "console.log(\"{$line}\");";
		}
	}
	echo "\r\n//]]>\r\n</script>";
}

