<?php

/*************************************************************
 * Ip info - retrieve information from ip
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class ipInfo {

	/**
	 * ipToCountry - get country code/name from ip, from: PhpTutorial.info
	 * @param $ip - the subject ip
	 * @param bool|false $fullInfo - if true will return an array of: country code of 2 and 3 letters + full country name + flag from images/flags directory, if false will return country code of 2 letters or "Unknown"
	 * @return array|string
	 */
	static public function ipToCountry($ip,$fullInfo = false) {

		$country = "";
		if($ip!="127.0.0.1" && $ip!="127.0.0.1:80") {
			$numbers = preg_split('/\./',$ip);
			include(ROOT.DS."labYard".DS."ipInfo".DS."ipToCountry".DS."ipFiles".DS.$numbers[0].".php");    // $ranges var
			include(ROOT.DS."labYard".DS."ipInfo".DS."ipToCountry".DS."ipFiles".DS."countries.php");       // $countries var
			$code = ($numbers[0] * 16777216) + ($numbers[1] * 65536) + ($numbers[2] * 256) + ($numbers[3]);
      if(!empty($ranges)) {
        foreach($ranges as $key => $value) {
          if($key<=$code) {
            if($ranges[$key][0]>=$code) {
              $country = $ranges[$key][1];
              break;
            }
          }
        }
      }
		}
		if($country=="" || $ip=="127.0.0.1" || $ip=="127.0.0.1:80") {
			$country      = "Unkown";
			$countryArray = array("2-lettersCode" => "Unkown","3-lettersCode" => "Unkown","countryName" => "Unkown");
		}
		else {
			$countryArray = array("2-lettersCode" => $country);

			$countryArray['3-lettersCode'] = $countries[$country][0];
			$countryArray['countryName']   = $countries[$country][1];
		}

		$fileToCheck = ROOT.DS."public".DS."images".DS."flags".DS.$country.".gif";
		if(file_exists($fileToCheck)) {
			$countryArray['flag'] = "<img src='\\images\\flags\\".$country.".gif' width='30' height='15'>";
		}
		else {
			$countryArray['flag'] = "<img src='flags/noflag.gif' width='30' height='15'>";
		}

		if($fullInfo!==false) {
			return $countryArray;
		}

		return $country;
	}
}

