<?php

/*************************************************************
 * Statistics - log users activities
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class statistics {

	private static $cfg;

	/**
	 * Constructor for statistics
	 */
	public function __construct() {

		self::$cfg = basic::loadCfg("statistics",false);       // userAgent config is set to load privately
	}

	/**
	 * Log to stats
	 */
	static public function logToStats() {

		$page = myHelpers::getServerUrl();
		foreach(self::$cfg['statistics']['omitAddresses'] as $key => $value) {
			self::$cfg['statistics']['omitAddresses'][$key] = basic::$cfg['site']['address']."/".$value;
		}

		if(!in_array($page,self::$cfg['statistics']['omitAddresses'])) {
			basic::load("userAgent","functions");
			$userData = userAgent::parseUserAgent();
			if(isset($_SERVER['HTTP_USER_AGENT'])) {
				$userData['userAgent'] = $_SERVER['HTTP_USER_AGENT'];
			}

			$userData['page']    = $page;
			$userData['referer'] = myHelpers::getServerReferer();
			basic::load("ipInfo","functions");
			$userData['country']   = strtolower(ipInfo::ipToCountry(myHelpers::getUserIp()));
			$userData['languages'] = strtolower(implode(",",lang::detectLanguagesFromBrowser()));

			if(basic::getConfig("db","main","activate")==true) {
        $db = basic::load(basic::getConfig("db","main","adapter"),'core/adapters');
        $db->insert($table = basic::getConfig("db","main","tablePrefix")."statistics",$preData = $userData,$advancedLead = true);
      }
		}
	}
}

