<?php

/*************************************************************
 * Model class
 * - model engine for the mvc
 * - support multiple adapters for db
 * - extend this class on: \application\models\"className"Model.php
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class advancedBlueprintsModel extends modelWarehouse {

  /**
   * Constructor for model
   */
  public function __construct() {

    parent::__construct();
  }

  /**
   * Initialize the required classes and variables
   */
  protected function init() {

    parent::init();
  }

  /**
   * Load data from file - the file must contain $data as array, can load in other languages too
   * @param $name - the directory and file name
   * @return mixed
   * @example - $this->loadData($name="documentationData/texter/url");
   */
  public function loadData($name) {

    return parent::loadData($name);
  }

  /**
   * Redirect to model
   * @param string $method - method name
   * @param boolean /string $model - model name
   * @param array $params - parameters to be used
   * @return array
   */
  public function redirectToModelMethod($method,$model = false,$params = array()) {

    return parent::redirectToModelMethod($method,$model,$params);
  }

  public function mmm() {

    return 1111121;
  }

  public function inTransaction() {
    return $this->db->inTransaction();
  }

  public function beginTransaction() {

    if(!$this->db->inTransaction()) {
      $this->db->beginTransaction();
    }
  }

  public function commit() {

    if($this->db->inTransaction()) {
      $this->db->commit();
    }
  }

  public function useDatabase($databaseName) {

    $this->db->useDatabase($databaseName);
  }

  public function createDatabase($databaseName) {

    $created = $this->db->createDatabase($databaseName);

    if($created) {
      return $created;
    }
    else {
      return false;
    }
  }

  public function createNewTable($tableName,$createData) {

    //   $tableName = "aaaa";

    /*    $sql ="CREATE TABLE IF NOT EXISTS ".$tableName."(
         ID INT( 11 ) AUTO_INCREMENT PRIMARY KEY,
         Prename VARCHAR( 50 ) NOT NULL,
         Name VARCHAR( 250 ) NOT NULL,
         StreetA VARCHAR( 150 ) NOT NULL,
         StreetB VARCHAR( 150 ) NOT NULL,
         StreetC VARCHAR( 150 ) NOT NULL,
         County VARCHAR( 100 ) NOT NULL,
         Postcode VARCHAR( 50 ) NOT NULL,
         Country VARCHAR( 50 ) NOT NULL),
         PRIMARY KEY ('ID')) CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB";*/

//    $created = $this->db->insert($table = basic::getConfig("db","main","tablePrefix")."items_full_spec",$createData,$advancedLead = true);
    $created = $this->db->create($table = basic::getConfig("db","main","tablePrefix").$tableName,$createData,$advancedLead = true);

    if($created) {
//      $created = (object)array("id" => $created['lastInsertId'],"createdAt" => $created['preData']['modifiedAt']);

//p($created);
      //   echo"ffffffffff";die();
      return $created;
    }
    else {
      return false;
    }
    //return 1111121;
  }

  public function insert($tableName,$data) {

    $inserted = $this->db->insert($table = basic::getConfig("db","main","tablePrefix").$tableName,$data,$advancedLead = true);

    if($inserted) {
      $inserted = (object)array("id" => $inserted['lastInsertId'],"createdAt" => $inserted['preData']['createdAt']);

      return $inserted;
    }
    else {
      return false;
    }
  }

  public function update($tableName,$leadId,$updateData) {


    /*    p($updateData);
        p($leadId);
        p($tableName);
        die();*/

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$tableName,$updateData,$where = array("leadId" => $leadId),$advancedLead = true);

    $imageData = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName,$col = array(
      "createdAt",
    ),$where = array("leadId" => $leadId,"isDeleted" => 0));

    if($updated && $imageData) {
      $edited = (object)array("id" => $updated['params'][0],"modifiedAt" => $imageData[0]['modifiedAt']);

      return $edited;
    }
    else {
      return false;
    }
  }

  public function updateEntry($tableName,$leadId,$updateData) {

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$tableName,$updateData,$where = array("leadId" => $leadId),$advancedLead = true);

    return $updated;
  }

  public function retrievePastEntry($tableName,$leadId,$actionId) {

    $return = $this->db->retrieveRowFromPast(basic::getConfig("db","main","tablePrefix").$tableName,$leadId,$actionId);

    if(isset($return)) {
      return $return;
    }

    return false;
  }

  public function getEntriesColumns($tableName,$columns,$rowsLimit) {

    $getEntriesInfo   = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName,$columns,"","","",$rowsLimit,"withLike","array");

    return $getEntriesInfo;
  }

  public function getPageEntries($tableName,$searchTerm,$searchableColumns,$pageColumn,$pageOrdering,$pageRowsLimit) {

    $orderByArray = [];

    if(!empty($pageColumn) && !empty($pageOrdering)) {
      $orderByArray = array($pageColumn => $pageOrdering);
    }

    if($searchTerm) {
      $where = [];

      if(!empty($searchableColumns) && is_array($searchableColumns)) {
        $where['leadId'] = $searchTerm;

        foreach($searchableColumns as $key => $field) {
          $where[$field] = $searchTerm;
        }
      }

      $totalRowsOnTable = $this->db->countTableRows($table = basic::getConfig("db","main","tablePrefix").$tableName,$where,"withLike");
      $getEntriesInfo   = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName,"*",$where,"",$orderByArray,$pageRowsLimit,"withLike","object");
    }
    else {
      $totalRowsOnTable = $this->db->countTableRows($table = basic::getConfig("db","main","tablePrefix").$tableName);
      $getEntriesInfo   = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName,"*","","",$orderByArray,$pageRowsLimit,"equivalent","object");
    }

    if(isset($getEntriesInfo) && !empty($totalRowsOnTable)) {
      return array($getEntriesInfo,$totalRowsOnTable);
    }

    return false;
  }

  public function updateEntryOrderingPosition($tableName,$leadId,$updateData) {

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$tableName,$updateData,$where = array("leadId" => $leadId),$advancedLead = true);

    return $updated;
  }

  public function getPastEntry($tableName,$leadId,$limit) {

    $where["leadId"]  = $leadId;
    $totalRowsOnTable = $this->db->countTableRows($table = basic::getConfig("db","main","tablePrefix").$tableName."_past");
    $getEntriesInfo   = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName."_past","*",$where,"",array("actionId" => "DESC"),$limit,"equivalent","array");

    if(!empty($getEntriesInfo) && !empty($totalRowsOnTable)) {
      return array($getEntriesInfo,$totalRowsOnTable);
    }

    return false;
  }

  public function getEntry($tableName,$leadId) {

    $where["leadId"] = $leadId;
    $getEntriesInfo  = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$tableName,"*",$where);

    if(isset($getEntriesInfo[0])) {
      return $getEntriesInfo[0];
    }

    return false;
  }

  public function entryActivation($tableName,$leadId,$updateData) {

    $active = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$tableName,$updateData,$where = array("leadId" => $leadId),$advancedLead = true);

    if(!empty($active['params'][0])) {
      $edited = (object)array("id" => $active['params'][0]);

      return $edited;
    }
    else {
      return false;
    }
  }

  public function blueprintDeletion($tableName) {

    $dropped = $this->db->drop($table = basic::getConfig("db","main","tablePrefix").$tableName);

    if(!empty($dropped['queryString'])) {
      $dropped = (object)array("table" => $dropped['queryString']);

      return $dropped;
    }
    else {
      return false;
    }
  }

  public function repeaterDeletion($tableName) {

    $dropped = $this->db->drop($table = basic::getConfig("db","main","tablePrefix").$tableName);

    if(!empty($dropped['queryString'])) {
      $dropped = (object)array("table" => $dropped['queryString']);

      return $dropped;
    }
    else {
      return false;
    }
  }

  public function entryDeletion($tableName,$leadId,$updateData,$permanentDelete) {

    $deleted = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$tableName,$updateData,$where = array("leadId" => $leadId),$advancedLead = true);

    if($permanentDelete==true) {
      $deletedPermanantly = $this->db->delete(basic::getConfig("db","main","tablePrefix").$tableName,$where,$leadId);
    }

    if(!empty($deleted['params'][0])) {
      $edited = (object)array("id" => $deleted['params'][0]);

      return $edited;
    }
    else {
      return false;
    }
  }

  public function countTableRows($tableName) {

    $countTableRows = $this->db->countTableRows(basic::getConfig("db","main","tablePrefix").$tableName);

    return $countTableRows;
  }

  public function checkIfTableExist($tableName) {

    $checkIfTableExist = $this->db->checkIfTableExist(basic::getConfig("db","main","tablePrefix").$tableName);

    return $checkIfTableExist;
  }

  public function renameTableName($tableName,$newTableName) {

    $renamedTable = $this->db->renameTableName(basic::getConfig("db","main","tablePrefix").$tableName,basic::getConfig("db","main","tablePrefix").$newTableName);

    return $renamedTable;
  }

  public function addColumn($tableName,$columnName,$dataType,$lengthSet,$addOn,$after = false) {

    $addColumn = $this->db->addColumn(basic::getConfig("db","main","tablePrefix").$tableName,$columnName,$dataType,$lengthSet,$addOn,$after);

    return $addColumn;
  }

  public function deleteColumn($tableName,$columnName) {

    $deleteColumn = $this->db->deleteColumn(basic::getConfig("db","main","tablePrefix").$tableName,$columnName);

    return $deleteColumn;
  }

  public function changeColumn($tableName,$oldColumnName,$newColumnName,$dataType,$lengthSet,$addOn,$after = false) {

    $changeColumn = $this->db->changeColumn(basic::getConfig("db","main","tablePrefix").$tableName,$oldColumnName,$newColumnName,$dataType,$lengthSet,$addOn,$after);

    return $changeColumn;
  }

  public function deleteAllEntriesButFirst($tableName) {

    $deleted = "";
    $params  = array();
    $this->db->beginTransaction();
    $sel = $this->db->prepare("SELECT min(leadId) as leadId FROM ".basic::getConfig("db","main","tablePrefix").$tableName);
    $sel->execute($params);
    $this->db->commit();
    $sel->setFetchMode(PDO::FETCH_ASSOC);

    $minLeadId = $sel->fetchAll();
    $minLeadId = !empty($minLeadId[0]['leadId']) ? $minLeadId[0]['leadId'] : "";

    if(!empty($minLeadId) && $minLeadId>0) {
      $params = array();
      $this->db->beginTransaction();
      $sel     = $this->db->prepare("DELETE FROM ".basic::getConfig("db","main","tablePrefix").$tableName." WHERE leadId > ".$minLeadId);
      $deleted = $sel->execute($params);
      $this->db->commit();
    }

    return $deleted;
  }

  public function createBridgeRepeaters($bridgeRepeatersName) {

    $createData = array(
      "columns" => array(
        //      "holderBlueprint" => array("varchar","40",""),
        //      "assetBlueprint"  => array("varchar","40",""),
        "holderLeadId" => array("int","11",""),
        "assetLeadId"  => array("int","11",""),
        "position"     => array("int","11",""),
        "isDefault"    => array("tinyint","1",""),
      ),
      //   "primaryKey" => "id",
      //   "characterSet" => "utf8 COLLATE utf8_general_ci",
      //   "engine"       => "InnoDB",
    );

    $bridgeTableCreated = $this->db->create($table = basic::getConfig("db","main","tablePrefix").$bridgeRepeatersName,$createData,true);

    return $bridgeTableCreated;
  }

  public function getRepeaterEntries($blueprintName,$repeaterBlueprintName,$leadId) {

    $bridgeRepeatersTableName = "bridge_repeaters_".$blueprintName."_".$repeaterBlueprintName;
    //   $where["holderBlueprint"] = $blueprintName;
    //   $where["assetBlueprint"]  = $repeaterBlueprintName;
    $where["holderLeadId"] = $leadId;

    $join = array(
      array(
        "JOIN",
        array(basic::getConfig("db","main","tablePrefix").$repeaterBlueprintName => "R"),
        array("B.assetLeadId" => "R.leadId")
      )
    );

    $orderBy = array(
      "position" => "ASC"
    );

    $getEntriesInfo = $this->db->find($table = array(basic::getConfig("db","main","tablePrefix").$bridgeRepeatersTableName => "B"),"B.leadId as bridgeLeadId,B.*,R.*",$where,$join,$orderBy);

    if(isset($getEntriesInfo)) {
      return $getEntriesInfo;
    }

    return false;
  }

  public function insertRepeatersData($blueprintName,$holderLeadId,$repeaterBlueprintName,$repeaterData) {

    $insertRepeater = [];

    foreach($repeaterData as $key => $value) {
      $insertRepeater = $this->insertRepeater($blueprintName,$repeaterBlueprintName,$holderLeadId,$key,$value['data'],$value['values']);
    }

    return $insertRepeater;
  }

  public function insertRepeater($blueprintName,$repeaterBlueprintName,$holderLeadId,$position,$repeaterDataToInsert,$repeaterValuesToInsert) {

    $repeaterAdvancedModel    = $this->insert($repeaterBlueprintName,$repeaterValuesToInsert);
    $bridgeRepeatersTableName = "bridge_repeaters_".$blueprintName."_".$repeaterBlueprintName;

    if(!empty($repeaterAdvancedModel->id)) {
      $bridgeRepeaterData = array(
        //    "holderBlueprint" => $blueprintName,
        //    "assetBlueprint"  => $repeaterBlueprintName,
        "holderLeadId" => $holderLeadId,
        "assetLeadId"  => $repeaterAdvancedModel->id,
        "position"     => $position,
        "isActive"     => $repeaterDataToInsert['isActive'],
        "isDeleted"    => $repeaterDataToInsert['isDeleted'],
        "isDefault"    => $repeaterDataToInsert['isDefault'],
      );

      $bridgeRepeaterAdvancedModel = $this->insert($bridgeRepeatersTableName,$bridgeRepeaterData);

      return $repeaterAdvancedModel;
    }
  }

  public function updateRepeaterIdIntoHolder($blueprintName,$assetColumn,$leadId,$assetLeadId) {

    $updateData = array(
      $assetColumn => $assetLeadId
    );

    $where = array(
      "leadId" => $leadId,
    );

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$blueprintName,$updateData,$where,$advancedLead = true);

    return $updated;
  }

  public function updateRepeaterValues($assetBlueprintName,$assetLeadId,$updateData) {

    $where = array(
      "leadId" => $assetLeadId,
    );

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$assetBlueprintName,$updateData,$where,$advancedLead = true);

    return $updated;
  }

  public function updateRepeaterBridge($holderBlueprintName,$assetBlueprintName,$holderLeadId,$assetLeadId,$position,$updateData,$bridgeLeadId = "") {

    $bridgeRepeatersTableName = "bridge_repeaters_".$holderBlueprintName."_".$assetBlueprintName;
    $where                    = array(
      //    "holderBlueprint" => $holderBlueprintName,
      //    "assetBlueprint"  => $assetBlueprintName,
      "holderLeadId" => $holderLeadId,
      "assetLeadId"  => $assetLeadId,
    );

    if(!empty($bridgeLeadId)) {
      $where['leadId'] = $bridgeLeadId;
    }

    $dataToUpdate = array(
      "isActive"  => $updateData['isActive'],
      "isDeleted" => $updateData['isDeleted'],
      "isDefault" => $updateData['isDefault'],
    );

    if(!empty($position)) {
      $dataToUpdate['position'] = $position;
    }

    $updated = $this->db->update($table = basic::getConfig("db","main","tablePrefix").$bridgeRepeatersTableName,$dataToUpdate,$where,$advancedLead = true);

    return $updated;
  }

  public function permanentDeleteRepeater($holderBlueprintName,$assetBlueprintName,$holderLeadId,$assetLeadId,$position,$bridgeLeadId = "") {

    $bridgeRepeatersTableName = "bridge_repeaters_".$holderBlueprintName."_".$assetBlueprintName;
    $whereBridge              = array(
      //     "holderBlueprint" => $holderBlueprintName,
      //     "assetBlueprint"  => $assetBlueprintName,
      "holderLeadId" => $holderLeadId,
      "assetLeadId"  => $assetLeadId,
    );

    $bridgeDeletedPermanently = $this->db->delete(basic::getConfig("db","main","tablePrefix").$bridgeRepeatersTableName,$whereBridge,$bridgeLeadId);

    $whereAsset = array(
      "leadId" => $assetLeadId,
    );

    $assetDeletedPermanently = $this->db->delete(basic::getConfig("db","main","tablePrefix").$assetBlueprintName,$whereAsset,$assetLeadId);

    return $assetDeletedPermanently;
  }
}

