<?php

/*************************************************************
 * Controller class
 * - controller engine for the mvc
 * - extend this class on: \application\controllers\"className"Controller.php
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class advancedController extends controllerWarehouse {

  /**
   * Constructor for controller
   * @param string $model
   * @param string $controller
   * @param string $action
   * @throws ReflectionException
   */
  public function __construct($model = "advancedModel",$controller = "advancedController",$action = "index") {

    parent::__construct($model,$controller,$action);
  }

  /**                                     // T2: maybe obsolete
   * Load classes from controller
   * @param string $class - name
   * @param string $directory - path under the labYard
   * @throws ReflectionException
   * @example $this->load($class="lang",$directory="core");
   */
  public function load($class,$directory = "") {

    parent::load($class,$directory);
  }

  /**                                     // T2: maybe obsolete
   * Load translations from controller - load the text translations file
   * @param string $textFile - file name to load under the path: text/translations
   * @return mixed
   * @example $this->translations($textFile="sil");
   */
  public function translations($textFile) {

    return parent::translations($textFile);
  }

  /**                                     // T2: maybe obsolete
   * Translate text from controller - return the translation text in the controller files
   * @param string $text - the text to be translated - written in the default language (en)
   * @param string /array $externalVar - containing the values that will effect the translation
   * @return string - the translation
   * @example $this->T($text="text");
   */
  public function T($text,$externalVar = "") {

    return parent::T($text,$externalVar);
  }

  /**
   * Add Js includes from controller init/action - add the Js files to the final Html page
   * @param string /array $file - file name - can be inside/outsource url
   * @example $this->addJsIncludes = array($file="js/auth/login-register.js");
   */
  public function addJsIncludes($file) {

    parent::addJsIncludes($file);
  }

  /**
   * Add Css includes from controller init/action - add the Css files to the final Html page
   * @param string /array $file - file name - can be inside/outsource url
   * @example $this->addCssIncludes($file="themes/".$this->currentTemplate."/css/auth.css");
   */
  public function addCssIncludes($file) {

    parent::addCssIncludes($file);
  }

  /**
   * Redirect to action
   * @param string $action - action name
   * @param boolean /string $controller - controller name
   * @param array $params - parameters to be used
   * @return array
   */
  public function redirectToAction($action,$controller = false,$params = array()) {

    return parent::redirectToAction($action,$controller,$params);
  }

  /**
   * Process default action view -  make the default action path
   * @param array $params - parameters to be used
   * @return string $this->view() - the page itself
   */
  public function defaultAction($params = null) {

    return parent::defaultAction($params);       // dispatch the result
  }

  /**
   * UnknownAction - feed 404 header to the client
   */
  public function unknownAction() {

    return parent::unknownAction();            // dispatch the result
  }

  /**
   * Load view from other location (from controller)
   * @param string $path - path where the view file exists (under view directory)
   * @param string $sub - path where the view file exists (under which architecture)
   * @return string - view output
   * @example $this->loadView($path="sil/userPasswordResetInvalid");
   */
  public function loadView($path,$sub = "") {

    $sub = basic::$cfg['site']['directory']['advanced'];

    return parent::loadView($path,$sub);            // dispatch the result
  }

  /**
   * Set a variables into view from controller
   * @param string $name - name of the variable
   * @param string $value - value of the variable
   * @example $this->set($name="timed",$value);        // will be $timed on view side
   */
  public function set($name,$value) {        // set the parameters to the template class

    parent::set($name,$value);
  }

  /**
   * View - returns the template result
   * @return string - view output
   */
  public function view() {

    return parent::view();                // dispatch the result
  }

  /**
   * Load action from view actually happens - including the view file
   * @param string $controller - the controller name
   * @param string $action - the action name
   */
  public function loadActionFromView($controller,$action) {

    parent::loadActionFromView($controller,$action);
  }

  /**
   * Include fragment file from fragments directory
   * @param string $path - path to the fragment
   * @param string $dir - path to the fragment (under which architecture)
   * @param string $architectureType - under which architecture
   * @param bool $renderAtOnce - if true will be rendered immediately
   * @return mixed
   * @example $this->includeFragment("themes/rim/fragments/navBar");        // from view
   */
  public function includeFragment($path,$dir = ADVANCEDPATH,$architectureType = "advanced",$renderAtOnce = false) {

    return parent::includeFragment($path,$dir,$architectureType = "advanced",$renderAtOnce);
  }

  /**
   * Auth level needed to view specific page
   * @param integer $num - the minimum auth level needed 0-5
   * @throws ReflectionException
   * @example $this->authLevelNeeded(4);
   */
  public function authLevelNeeded($num) {

    parent::authLevelNeeded($num);
  }

  /**
   * Before action - the function that comes before all the functions in the controller class
   */
  public function beforeAction() {

    parent::beforeAction();
  }

  /**
   * After action - the function that comes before all the functions in the controller class
   */
  public function afterAction() {

    parent::afterAction();
  }

  /**
   * Show auth (sil) alert
   */
  public function showAuthAlert() {

    parent::showAuthAlert();
  }    // calls this function on "template.class" - happens only if we use loadActionFromView

  /**
   * Set canonical
   * @param string $address - set the canonical address for the page/controller
   * @example $this->setCanonical("ksjbfsjkdfjgsbvjsfsd.html"); from controller
   */
  public function setCanonical($address) {

    parent::setCanonical($address);
  }

  /**
   * Set do not render part of template
   * @param string /array $set - set the parts (themePlans) that we want to remove from page
   * @example $this->setDoNotRenderPartOfTemplate(array("header","footer")); from controller
   */
  public function setDoNotRenderPartOfTemplate($set) {

    parent::setDoNotRenderPartOfTemplate($set);
  }

  /**
   * Set operators to activate
   * @param array $set - set the operators to activate on page/controller
   * @example $this->setOperatorsToActivate(array('default','login','login888'));
   * @example $this->setOperatorsToActivate(array(
   *                    'position'=>'right',
   *                    'file'=>'unique',
   *                    'title'=>'unique999',
   *                    'allowMoreThenOnce'=>2,
   *                    'mustShow'=>1,
   *                    ));
   */
  public function setOperatorsToActivate(array $set) {

    parent::setOperatorsToActivate($set);
  }

  /**
   * Unset operator from controller
   * @param string $toUnset - the operator file to unset, the operator will not show on that page/controller
   * @example $this->unsetOperator();                    // * empty value will unset all operators
   * @example $this->unsetOperator("serverLoad");        // unset by file name
   */
  public function unsetOperator($toUnset = "") {

    parent::unsetOperator($toUnset);
  }

  /**
   * Initialize the required classes and variables
   */
  protected function init() {

    //  $this->setOperatorsToActivate(array('default','advancedEntryMenu',$this->T("Advanced entry menu")));

    parent::init();
  }
}

