<?php

/*************************************************************
 * Model class
 * - model engine for the mvc
 * - support multiple adapters for db
 * - extend this class on: \application\models\"className"Model.php
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2018 T2
 * @link      http://limbercode.com
 *************************************************************/
class model extends modelWarehouse {

	/**
	 * Constructor for model
	 */
	public function __construct() {

		parent::__construct();
	}

	/**
	 * Initialize the required classes and variables
	 */
	protected function init() {

		parent::init();
	}

	/**
	 * Load data from file - the file must contain $data as array, can load in other languages too
	 * @param $name - the directory and file name
	 * @return mixed
	 * @example - $this->loadData($name="documentationData/texter/url");
	 */
	public function loadData($name) {

		return parent::loadData($name);
	}

  /**
   * Redirect to action
   * @param string $method - method name
   * @param boolean /string $model - model name
   * @param array $params - parameters to be used
   * @return array
   */
  public function redirectToModelMethod($method,$model = false,$params = array()) {

    return parent::redirectToModelMethod($method,$model,$params);
  }







  public function getConnectedEntries($blueprintName,$leadId) {

      $data = $this->db->find($table = basic::getConfig("db","main","tablePrefix").$blueprintName,$col = array(
        "*",
      ),$where = array("leadId" => $leadId,"isActive" => 1,"isDeleted" => 0));

    if(!empty($data[0])) {
      return $data[0];
    }
  }




  public function getRepeaterEntries($blueprintName,$repeaterBlueprintName,$leadId) {

    $bridgeRepeatersTableName = "bridge_repeaters_".$blueprintName."_".$repeaterBlueprintName;
    //   $where["holderBlueprint"] = $blueprintName;
    //   $where["assetBlueprint"]  = $repeaterBlueprintName;
    $where["holderLeadId"] = $leadId;

    $join = array(
      array(
        "JOIN",
        array(basic::getConfig("db","main","tablePrefix").$repeaterBlueprintName => "R"),
        array("B.assetLeadId" => "R.leadId")
      )
    );

    $orderBy = array(
      "position" => "ASC"
    );

    $getEntriesInfo = $this->db->find($table = array(basic::getConfig("db","main","tablePrefix").$bridgeRepeatersTableName => "B"),"B.leadId as bridgeLeadId,B.*,R.*",$where,$join,$orderBy);

    if(isset($getEntriesInfo)) {
      return $getEntriesInfo;
    }

    return false;
  }



}

