<?php

/*************************************************************
 * The system starting point:
 * - basic config of directories
 * - start the session
 * - loading site/auth configuration
 * - loads bootstrap
 * @author    S M Kessner <limbercode@gmail.com>
 * @copyright 2010-2017 T2
 * @link      http://limbercode.com
 *************************************************************/

define('DS',DIRECTORY_SEPARATOR);                       // define the directory separator
define('ROOT',dirname(dirname(__FILE__)));         // define the application path
define('CONFIGPATH',ROOT.DS.'config'.DS);               // define the config path
define('IMPERMANENTPATH',ROOT.DS.'impermanent'.DS);     // define the impermanent path
define('LABYARDPATH',ROOT.DS.'labYard'.DS);             // define the labYard path
define('OUTSOURCEPATH',ROOT.DS.'outSource'.DS);         // define the outSource path
define('SOURCEPATH',ROOT.DS.'source'.DS);               // define the source path

require_once(LABYARDPATH.DS."installCheckUp.php");

$errorsPath = "./impermanent/logs/";
if(!is_dir($errorsPath)) {
  mkdir($errorsPath,0755,true);
}

ini_set('error_log', $errorsPath."uncaught-errors.log");

require_once(LABYARDPATH.'core'.DS.'basic.class.php');
$basic = new basic();                                   // load the cfg variable to basic::$cfg

define('APPLICATIONPATH',ROOT.DS.basic::$cfg['site']['directory']['application'].DS);  // defines the application path
define('ADVANCEDPATH',ROOT.DS.basic::$cfg['site']['directory']['advanced'].DS);        // defines the advanced path
define('APIPATH',ROOT.DS.basic::$cfg['site']['directory']['api'].DS);                  // defines the api path
define('OPERATORSPATH',ROOT.DS.basic::$cfg['site']['directory']['operators'].DS);      // defines the operator path

if(!is_array(basic::$cfg)) {
	echo "Config core file is missing - config.php (81300)";
}

// the routing url, we need to use original 'QUERY_STRING' from server parameter because php has parsed the url if we use $_GET
$route = isset($_GET['route']) ? preg_replace('/^route=(.*)/','$1',$_SERVER['QUERY_STRING']) : '';

if($_SERVER['REQUEST_URI']=="/favicon.ico") {   // causing a fake request - we don't need that - so redirecting to the right place
	header("Location: /public/images/favicon.ico");
	die();
}

require_once(LABYARDPATH.'bootstrap.php');  // start to dispatch

