document.addEventListener('DOMContentLoaded',function() {

	var outer = document.getElementById('outer'),
		outerRect = outer.getBoundingClientRect(),
		lock = document.getElementById('lock'),
		isTouch = 'ontouchstart' in document.documentElement,
		lockRect = null,
		dragProps = null;

	function dragStart(e) {

		lockRect = lock.getBoundingClientRect();
		var x = getX(e);
		dragProps = {
			start:lockRect.left - outerRect.left,
			mouseStart:x,
			newX:0
		}
		lock.classList.add('dragging');
		document.addEventListener('mousemove',dragLock,false);
		document.addEventListener('touchmove',dragLock,false);
		document.addEventListener('mouseup',dragStop);
		document.addEventListener('touchend',dragStop);
	}

	function dragStop(reset) {

		lock.classList.remove('dragging');
		if(reset!==false) {
			lock.style.left = '0px';
		}
		document.removeEventListener('mousemove',dragLock,false);
		document.removeEventListener('touchmove',dragLock,false);
		document.removeEventListener('mouseup',dragStop);
		document.removeEventListener('touchend',dragStop);
	}

	function unlock() {

		//	document.getElementById("authForm").submit();
		document.getElementById("authForm").submitButton.click();       // fix - to activate html5 validation

		var checkHtml5Validation = document.getElementById("authForm").checkValidity();

		if(checkHtml5Validation!==false) {
			outer.classList.add('unlocked');

			document.getElementById('swipeText').classList.add('swipeTextUnlocked');
			document.getElementById('lock').classList.add('lockUnlocked');
			document.getElementById('swipeText').innerHTML = document.getElementById('unlockerMessage').innerHTML;

			dragStop(false);
			lock.removeEventListener('mousedown',dragStart);
			lock.removeEventListener('touchstart',dragStart);
		}
	}

	function dragLock(e) {

		e.preventDefault();
		var posX = getX(e);

		var mouseDiff = posX - dragProps.mouseStart,
			maxX = outerRect.width - lockRect.width,
			newX = dragProps.start + mouseDiff,
			border = parseInt(getComputedStyle(document.getElementById('outer'),null).getPropertyValue('border-left-width'),10) * 2,
			newX = clamp(newX,0,maxX - border);

		lock.style.left = newX + 'px';
		if(newX >= maxX - border) {
			unlock();
		}
	}

	function clamp(value,min,max) {

		return Math.min(Math.max(value,min),max);
	}

	function getX(event) {

		if(isTouch===true) {
		//	return event.touches[0].pageX;  // suppose to, but not working like this
			return event.clientX;
		}
		else {
			return event.clientX;
		}
	}

	lock.addEventListener('mousedown',dragStart);
	lock.addEventListener('touchstart',dragStart);

},false);

