![FwCms](https://raw.github.com/yoyo/PHPMailer/master/examples/images/x.png)
# Limber Code Fw Cms

This framework can be used as mvc project with the benefits of cms.

## Phase 1.

- prototype orm system - will be progressed on Phase 3.

## Phase 2.

- Mvc construct for all uses and purposes, separated mvc for: pages,operators and api
- Sil - secure imbibe login system enhanced with all basics of secure site
- Sil - security method uses versatile options to use cookies/sessions and switch between them for every variable set in the authentication class and much much more
- Template engine that controls areas of the page like: operators, fragments
- Full multi language support on all pages
- unique polyphonic translation system with low memory consumption
- Flexible config method: php file array/xml/db
- Seo compatible with google use, generates Clean URLs
- Real time development tools like: error notification system/alerts/memory usage
- Db Ui system like no other - catches mysql queries and display them live - for dev easy use
- Error control mechanism - reduce the use of error.log by 90%
- Error control system notify the master admin for any illegal use, separated errors log for fatal and non-fatal errors
- Alert mechanism for all system errors
- Compatible with PHP 5.3 and later

## Phase 3. - for the road to come:

- Backend advance admin system - more then orm
- admin backend for site configuration
- plugins (+mvc) that will be installed automatically from zip/rar/gz file


# Documentation:

## License:

You are permitted to copy and modify for test purposes only. later on the license will be changed. this is a test version.

Disclaimer of Warranty:
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, WARRANTIES OF QUALITY, PERFORMANCE, NON-INFRINGEMENT, MERCHANTABILITY, OR FITNESS FOR A PARTICULAR PURPOSE.


## Server Requirements:

- PHP version 5.3 or newer (PHP version 7 is compatible).
- A Database is required for most web application programming. Current supported mysql PDO and more.


## Installation Instructions

- Unzip the package.
- Upload the content folders and files to your server as is to a chosen directory.
- Open the config/config.php file with a text editor. All the important setting are at this file, you may change that as you pleased. please set $cfg['site']['address'] + $cfg['site']['directory']['main'] and your db settings. Later on when you get settled you may want to change $cfg['site']['environment'].


## Troubleshooting

- The system is very easy to use with full UI helper that will guide you on each step you make, issuing notifications about things that have to be fixed with detailed answers.
- The system also catches php errors and display them with detailed backtrace and errors type. (also catches ajax errors as they happen)


## 4 levels of mvc: application, admin application (advanced), operators and api.

Model View Controller (MVC) - design pattern:
- The Model represents the data, handles interaction with the database. The model does NOT depend on the controller or the view.
- The view generates an output presentation to the user based on changes in model.
- The controller provides model data to the view, and interprets user actions such as button clicks. The controller depends on the view and the model. In some cases, the controller and the view are the same object.

## application mvc:

directories:

controller - baseDir\architecture\application\controllers
model - baseDir\architecture\application\models (optional)
view - baseDir\architecture\application\views (optional)
theme - baseDir\architecture\application\themes

### controller use:
class nameController extends controller



## admin application mvc (advanced):
The idea is to separate the admin panel from regular UI

directories:

controller - baseDir\architecture\advanced\controllers
model - baseDir\architecture\advanced\models (optional)
view - baseDir\architecture\advanced\views (optional)
theme - baseDir\architecture\advanced\themes        -------------------------- not yet decided

## operators mvc:
Separate blocks from the main application

directories:

controller - baseDir\architecture\operators\controllers (optional)
model - baseDir\architecture\operators\models (optional)
view - baseDir\architecture\operators\views

## api mvc:
The meant is to use smaller amount of resources then the application mvc

directories:

controller - baseDir\architecture\api\controllers
model - baseDir\architecture\api\models (optional)




